
/*============================================================================*/
/*                       L a b W i n d o w s / C V I                          */
/*----------------------------------------------------------------------------*/
/*    Copyright (c) National Instruments 1987-1996.  All Rights Reserved.     */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Title:   basicsdk.h                                                        */
/* Purpose: The purpose of this file is to document the Windows SDK           */
/*          functions that are automatically loaded into LabWindows/CVI.      */
/*                                                                            */
/*          Do not include file in your source files.  Use windows.h          */
/*          instead.                                                          */
/*                                                                            */
/*          You can make special use for this file under the following        */
/*          conditions:                                                       */
/*                                                                            */
/*          - you are using an external compiler to create an executable      */
/*            or DLL, and                                                     */
/*          - you are using LoadExternalModule to load an object or library   */
/*            file, and                                                       */
/*          - the run-time object or library module references one of the     */
/*            SDK functions declared in this file.                            */
/*                                                                            */
/*          Use the External Compiler Support command in the Build menu of    */
/*          the Project window.  Specify this file (or a file that includes   */
/*          this file as the Header File in the Other Symbols section.        */
/*          Include the associated object file in your external compiler      */
/*          project.                                                          */
/*                                                                            */
/*          Notice that the declarations in this file use mostly intrinsic    */
/*          types rather than the Windows types.  That is that so you do      */
/*          not have to include windows.h.                                    */
/*                                                                            */
/*          If your run-time object or library module references SDK          */
/*          functions not declared in this file, create a similar file        */
/*          with declarations for those functions.  (You can find a list      */
/*          of these functions in cvi\sdk\sdkfuncs.txt.)                      */
/*                                                                            */
/*============================================================================*/



struct tagPOINT
{
    long  x;
    long  y;
};
struct _COORD {
    short X;
    short Y;
};

extern long __stdcall InterlockedIncrement(long *lpAddend);
extern long __stdcall InterlockedDecrement(long *lpAddend);
extern long __stdcall InterlockedExchange(long *Target, long Value);
extern int __stdcall FreeResource(void *hResData);
extern void *__stdcall LockResource(void *hResData);
extern int __stdcall FreeLibrary(struct HINSTANCE__ *hLibModule);
extern void __stdcall FreeLibraryAndExitThread(struct HINSTANCE__ *hLibModule,
                                               unsigned long dwExitCode);
extern int __stdcall DisableThreadLibraryCalls(struct HINSTANCE__ *hLibModule);
extern int (__stdcall *__stdcall GetProcAddress(struct HINSTANCE__ *hModule,
            const char *lpProcName))(void);
extern unsigned long __stdcall GetVersion(void);
extern void *__stdcall GlobalAlloc(unsigned int uFlags, unsigned long dwBytes);
extern void *__stdcall GlobalReAlloc(void *hMem, unsigned long dwBytes,
                                     unsigned int uFlags);
extern unsigned long __stdcall GlobalSize(void *hMem);
extern unsigned int __stdcall GlobalFlags(void *hMem);
extern void *__stdcall GlobalLock(void *hMem);
extern void *__stdcall GlobalHandle(const void *pMem);
extern int __stdcall GlobalUnlock(void *hMem);
extern void *__stdcall GlobalFree(void *hMem);
extern unsigned int __stdcall GlobalCompact(unsigned long dwMinFree);
extern void __stdcall GlobalFix(void *hMem);
extern void __stdcall GlobalUnfix(void *hMem);
extern void *__stdcall GlobalWire(void *hMem);
extern int __stdcall GlobalUnWire(void *hMem);
extern void __stdcall GlobalMemoryStatus(struct _MEMORYSTATUS *lpBuffer);
extern void *__stdcall LocalAlloc(unsigned int uFlags, unsigned int uBytes);
extern void *__stdcall LocalReAlloc(void *hMem, unsigned int uBytes,
                                    unsigned int uFlags);
extern void *__stdcall LocalLock(void *hMem);
extern void *__stdcall LocalHandle(const void *pMem);
extern int __stdcall LocalUnlock(void *hMem);
extern unsigned int __stdcall LocalSize(void *hMem);
extern unsigned int __stdcall LocalFlags(void *hMem);
extern void *__stdcall LocalFree(void *hMem);
extern unsigned int __stdcall LocalShrink(void *hMem, unsigned int cbNewSize);
extern unsigned int __stdcall LocalCompact(unsigned int uMinFree);
extern int __stdcall FlushInstructionCache(void *hProcess, const void *lpBaseAddress,
                                           unsigned long dwSize);
extern void *__stdcall VirtualAlloc(void *lpAddress, unsigned long dwSize,
                                    unsigned long flAllocationType, unsigned long flProtect);
extern int __stdcall VirtualFree(void *lpAddress, unsigned long dwSize,
                                 unsigned long dwFreeType);
extern int __stdcall VirtualProtect(void *lpAddress, unsigned long dwSize,
                                    unsigned long flNewProtect, unsigned long *lpflOldProtect);
extern unsigned long __stdcall VirtualQuery(const void *lpAddress,
                                            struct _MEMORY_BASIC_INFORMATION *lpBuffer, unsigned long dwLength);
extern int __stdcall VirtualProtectEx(void *hProcess, void *lpAddress,
                                      unsigned long dwSize, unsigned long flNewProtect, unsigned long *lpflOldProtect);
extern unsigned long __stdcall VirtualQueryEx(void *hProcess, const void *lpAddress,
                                              struct _MEMORY_BASIC_INFORMATION *lpBuffer, unsigned long dwLength);
extern void *__stdcall HeapCreate(unsigned long flOptions, unsigned long dwInitialSize,
                                  unsigned long dwMaximumSize);
extern int __stdcall HeapDestroy(void *hHeap);
extern void *__stdcall HeapAlloc(void *hHeap, unsigned long dwFlags,
                                 unsigned long dwBytes);
extern void *__stdcall HeapReAlloc(void *hHeap, unsigned long dwFlags,
                                   void *lpMem, unsigned long dwBytes);
extern int __stdcall HeapFree(void *hHeap, unsigned long dwFlags,
                              void *lpMem);
extern unsigned long __stdcall HeapSize(void *hHeap, unsigned long dwFlags,
                                        const void *lpMem);
extern int __stdcall HeapValidate(void *hHeap, unsigned long dwFlags,
                                  const void *lpMem);
extern unsigned int __stdcall HeapCompact(void *hHeap, unsigned long dwFlags);
extern void *__stdcall GetProcessHeap(void);
extern unsigned long __stdcall GetProcessHeaps(unsigned long NumberOfHeaps,
                                               void **ProcessHeaps);
extern int __stdcall HeapLock(void *hHeap);
extern int __stdcall HeapUnlock(void *hHeap);
extern int __stdcall HeapWalk(void *hHeap, struct _PROCESS_HEAP_ENTRY *lpEntry);
extern int __stdcall GetBinaryTypeA(const char *lpApplicationName,
                                    unsigned long *lpBinaryType);
extern int __stdcall GetBinaryTypeW(const char *lpApplicationName,
                                    unsigned long *lpBinaryType);
extern unsigned long __stdcall GetShortPathNameA(const char *lpszLongPath,
                                                 char *lpszShortPath, unsigned long cchBuffer);
extern unsigned long __stdcall GetShortPathNameW(const char *lpszLongPath,
                                                 char *lpszShortPath, unsigned long cchBuffer);
extern int __stdcall GetProcessAffinityMask(void *hProcess, unsigned long *lpProcessAffinityMask,
                                            unsigned long *lpSystemAffinityMask);
extern int __stdcall GetProcessTimes(void *hProcess, struct _FILETIME *lpCreationTime,
                                     struct _FILETIME *lpExitTime, struct _FILETIME *lpKernelTime, struct _FILETIME *lpUserTime);
extern int __stdcall GetProcessWorkingSetSize(void *hProcess, unsigned long *lpMinimumWorkingSetSize,
                                              unsigned long *lpMaximumWorkingSetSize);
extern int __stdcall SetProcessWorkingSetSize(void *hProcess, unsigned long dwMinimumWorkingSetSize,
                                              unsigned long dwMaximumWorkingSetSize);
extern void *__stdcall OpenProcess(unsigned long dwDesiredAccess,
                                   int bInheritHandle, unsigned long dwProcessId);
extern void *__stdcall GetCurrentProcess(void);
extern unsigned long __stdcall GetCurrentProcessId(void);
extern void __stdcall ExitProcess(unsigned int uExitCode);
extern int __stdcall TerminateProcess(void *hProcess, unsigned int uExitCode);
extern int __stdcall GetExitCodeProcess(void *hProcess, unsigned long *lpExitCode);
extern void __stdcall FatalExit(int ExitCode);
extern char *__stdcall GetEnvironmentStrings(void);
extern char *__stdcall GetEnvironmentStringsW(void);
extern int __stdcall FreeEnvironmentStringsA(char *);
extern int __stdcall FreeEnvironmentStringsW(char *);
extern void __stdcall RaiseException(unsigned long dwExceptionCode,
                                     unsigned long dwExceptionFlags, unsigned long nNumberOfArguments,
                                     const unsigned long *lpArguments);
extern long __stdcall UnhandledExceptionFilter(struct _EXCEPTION_POINTERS *ExceptionInfo);
extern long (__stdcall *__stdcall SetUnhandledExceptionFilter(long (__stdcall *lpTopLevelExceptionFilter)(struct _EXCEPTION_POINTERS *ExceptionInfo)))(struct _EXCEPTION_POINTERS *ExceptionInfo);
extern void *__stdcall CreateThread(struct _SECURITY_ATTRIBUTES *lpThreadAttributes,
                                    unsigned long dwStackSize, unsigned long (__stdcall *lpStartAddress)(void *lpThreadParameter),
                                    void *lpParameter, unsigned long dwCreationFlags, unsigned long *lpThreadId);
extern void *__stdcall CreateRemoteThread(void *hProcess, struct _SECURITY_ATTRIBUTES *lpThreadAttributes,
                                          unsigned long dwStackSize, unsigned long (__stdcall *lpStartAddress)(void *lpThreadParameter),
                                          void *lpParameter, unsigned long dwCreationFlags, unsigned long *lpThreadId);
extern void *__stdcall GetCurrentThread(void);
extern unsigned long __stdcall GetCurrentThreadId(void);
extern unsigned long __stdcall SetThreadAffinityMask(void *hThread,
                                                     unsigned long dwThreadAffinityMask);
extern int __stdcall SetThreadPriority(void *hThread, int nPriority);
extern int __stdcall GetThreadPriority(void *hThread);
extern int __stdcall GetThreadTimes(void *hThread, struct _FILETIME *lpCreationTime,
                                    struct _FILETIME *lpExitTime, struct _FILETIME *lpKernelTime, struct _FILETIME *lpUserTime);
extern void __stdcall ExitThread(unsigned long dwExitCode);
extern int __stdcall TerminateThread(void *hThread, unsigned long dwExitCode);
extern int __stdcall GetExitCodeThread(void *hThread, unsigned long *lpExitCode);
extern int __stdcall GetThreadSelectorEntry(void *hThread, unsigned long dwSelector,
                                            struct _LDT_ENTRY *lpSelectorEntry);
extern unsigned long __stdcall GetLastError(void);
extern void __stdcall SetLastError(unsigned long dwErrCode);
extern int __stdcall GetOverlappedResult(void *hFile, struct _OVERLAPPED *lpOverlapped,
                                         unsigned long *lpNumberOfBytesTransferred, int bWait);
extern void *__stdcall CreateIoCompletionPort(void *FileHandle,
                                              void *ExistingCompletionPort, unsigned long CompletionKey, unsigned long NumberOfConcurrentThreads);
extern int __stdcall GetQueuedCompletionStatus(void *CompletionPort,
                                               unsigned long *lpNumberOfBytesTransferred, unsigned long *lpCompletionKey,
                                               struct _OVERLAPPED **lpOverlapped, unsigned long dwMilliseconds);
extern unsigned int __stdcall SetErrorMode(unsigned int uMode);
extern int __stdcall ReadProcessMemory(void *hProcess, const void *lpBaseAddress,
                                       void *lpBuffer, unsigned long nSize, unsigned long *lpNumberOfBytesRead);
extern int __stdcall WriteProcessMemory(void *hProcess, void *lpBaseAddress,
                                        void *lpBuffer, unsigned long nSize, unsigned long *lpNumberOfBytesWritten);
extern int __stdcall GetThreadContext(void *hThread, struct _CONTEXT *lpContext);
extern int __stdcall SetThreadContext(void *hThread, const struct _CONTEXT *lpContext);
extern unsigned long __stdcall SuspendThread(void *hThread);
extern unsigned long __stdcall ResumeThread(void *hThread);
extern void __stdcall DebugBreak(void);
extern int __stdcall WaitForDebugEvent(struct _DEBUG_EVENT *lpDebugEvent,
                                       unsigned long dwMilliseconds);
extern int __stdcall ContinueDebugEvent(unsigned long dwProcessId,
                                        unsigned long dwThreadId, unsigned long dwContinueStatus);
extern int __stdcall DebugActiveProcess(unsigned long dwProcessId);
extern void __stdcall InitializeCriticalSection(struct _RTL_CRITICAL_SECTION *lpCriticalSection);
extern void __stdcall EnterCriticalSection(struct _RTL_CRITICAL_SECTION *lpCriticalSection);
extern void __stdcall LeaveCriticalSection(struct _RTL_CRITICAL_SECTION *lpCriticalSection);
extern void __stdcall DeleteCriticalSection(struct _RTL_CRITICAL_SECTION *lpCriticalSection);
extern int __stdcall SetEvent(void *hEvent);
extern int __stdcall ResetEvent(void *hEvent);
extern int __stdcall PulseEvent(void *hEvent);
extern int __stdcall ReleaseSemaphore(void *hSemaphore, long lReleaseCount,
                                      long *lpPreviousCount);
extern int __stdcall ReleaseMutex(void *hMutex);
extern unsigned long __stdcall WaitForSingleObject(void *hHandle,
                                                   unsigned long dwMilliseconds);
extern unsigned long __stdcall WaitForMultipleObjects(unsigned long nCount,
                                                      void *const *lpHandles, int bWaitAll, unsigned long dwMilliseconds);
extern void __stdcall Sleep(unsigned long dwMilliseconds);
extern void *__stdcall LoadResource(struct HINSTANCE__ *hModule,
                                    struct HRSRC__ *hResInfo);
extern unsigned long __stdcall SizeofResource(struct HINSTANCE__ *hModule,
                                              struct HRSRC__ *hResInfo);
extern unsigned short __stdcall GlobalDeleteAtom(unsigned short nAtom);
extern int __stdcall InitAtomTable(unsigned long nSize);
extern unsigned short __stdcall DeleteAtom(unsigned short nAtom);
extern unsigned int __stdcall SetHandleCount(unsigned int uNumber);
extern unsigned long __stdcall GetLogicalDrives(void);
extern int __stdcall LockFile(void *hFile, unsigned long dwFileOffsetLow,
                              unsigned long dwFileOffsetHigh, unsigned long nNumberOfBytesToLockLow,
                              unsigned long nNumberOfBytesToLockHigh);
extern int __stdcall UnlockFile(void *hFile, unsigned long dwFileOffsetLow,
                                unsigned long dwFileOffsetHigh, unsigned long nNumberOfBytesToUnlockLow,
                                unsigned long nNumberOfBytesToUnlockHigh);
extern int __stdcall LockFileEx(void *hFile, unsigned long dwFlags,
                                unsigned long dwReserved, unsigned long nNumberOfBytesToLockLow,
                                unsigned long nNumberOfBytesToLockHigh, struct _OVERLAPPED *lpOverlapped);
extern int __stdcall UnlockFileEx(void *hFile, unsigned long dwReserved,
                                  unsigned long nNumberOfBytesToUnlockLow, unsigned long nNumberOfBytesToUnlockHigh,
                                  struct _OVERLAPPED *lpOverlapped);
extern int __stdcall GetFileInformationByHandle(void *hFile, struct _BY_HANDLE_FILE_INFORMATION *lpFileInformation);
extern unsigned long __stdcall GetFileType(void *hFile);
extern unsigned long __stdcall GetFileSize(void *hFile, unsigned long *lpFileSizeHigh);
extern void *__stdcall GetStdHandle(unsigned long nStdHandle);
extern int __stdcall SetStdHandle(unsigned long nStdHandle, void *hHandle);
extern int __stdcall WriteFile(void *hFile, const void *lpBuffer,
                               unsigned long nNumberOfBytesToWrite, unsigned long *lpNumberOfBytesWritten,
                               struct _OVERLAPPED *lpOverlapped);
extern int __stdcall ReadFile(void *hFile, void *lpBuffer, unsigned long nNumberOfBytesToRead,
                              unsigned long *lpNumberOfBytesRead, struct _OVERLAPPED *lpOverlapped);
extern int __stdcall FlushFileBuffers(void *hFile);
extern int __stdcall DeviceIoControl(void *hDevice, unsigned long dwIoControlCode,
                                     void *lpInBuffer, unsigned long nInBufferSize, void *lpOutBuffer,
                                     unsigned long nOutBufferSize, unsigned long *lpBytesReturned, struct _OVERLAPPED *lpOverlapped);
extern int __stdcall SetEndOfFile(void *hFile);
extern unsigned long __stdcall SetFilePointer(void *hFile, long lDistanceToMove,
                                              long *lpDistanceToMoveHigh, unsigned long dwMoveMethod);
extern int __stdcall FindClose(void *hFindFile);
extern int __stdcall GetFileTime(void *hFile, struct _FILETIME *lpCreationTime,
                                 struct _FILETIME *lpLastAccessTime, struct _FILETIME *lpLastWriteTime);
extern int __stdcall SetFileTime(void *hFile, const struct _FILETIME *lpCreationTime,
                                 const struct _FILETIME *lpLastAccessTime, const struct _FILETIME *lpLastWriteTime);
extern int __stdcall CloseHandle(void *hObject);
extern int __stdcall DuplicateHandle(void *hSourceProcessHandle,
                                     void *hSourceHandle, void *hTargetProcessHandle, void **lpTargetHandle,
                                     unsigned long dwDesiredAccess, int bInheritHandle, unsigned long dwOptions);
extern int __stdcall GetHandleInformation(void *hObject, unsigned long *lpdwFlags);
extern int __stdcall SetHandleInformation(void *hObject, unsigned long dwMask,
                                          unsigned long dwFlags);
extern unsigned long __stdcall LoadModule(const char *lpModuleName,
                                          void *lpParameterBlock);
extern unsigned int __stdcall WinExec(const char *lpCmdLine, unsigned int uCmdShow);
extern int __stdcall ClearCommBreak(void *hFile);
extern int __stdcall ClearCommError(void *hFile, unsigned long *lpErrors,
                                    struct _COMSTAT *lpStat);
extern int __stdcall SetupComm(void *hFile, unsigned long dwInQueue,
                               unsigned long dwOutQueue);
extern int __stdcall EscapeCommFunction(void *hFile, unsigned long dwFunc);
extern int __stdcall GetCommConfig(void *hCommDev, struct _COMMCONFIG *lpCC,
                                   unsigned long *lpdwSize);
extern int __stdcall GetCommMask(void *hFile, unsigned long *lpEvtMask);
extern int __stdcall GetCommProperties(void *hFile, struct _COMMPROP *lpCommProp);
extern int __stdcall GetCommModemStatus(void *hFile, unsigned long *lpModemStat);
extern int __stdcall GetCommState(void *hFile, struct _DCB *lpDCB);
extern int __stdcall GetCommTimeouts(void *hFile, struct _COMMTIMEOUTS *lpCommTimeouts);
extern int __stdcall PurgeComm(void *hFile, unsigned long dwFlags);
extern int __stdcall SetCommBreak(void *hFile);
extern int __stdcall SetCommConfig(void *hCommDev, struct _COMMCONFIG *lpCC,
                                   unsigned long dwSize);
extern int __stdcall SetCommMask(void *hFile, unsigned long dwEvtMask);
extern int __stdcall SetCommState(void *hFile, struct _DCB *lpDCB);
extern int __stdcall SetCommTimeouts(void *hFile, struct _COMMTIMEOUTS *lpCommTimeouts);
extern int __stdcall TransmitCommChar(void *hFile, char cChar);
extern int __stdcall WaitCommEvent(void *hFile, unsigned long *lpEvtMask,
                                   struct _OVERLAPPED *lpOverlapped);
extern unsigned long __stdcall SetTapePosition(void *hDevice, unsigned long dwPositionMethod,
                                               unsigned long dwPartition, unsigned long dwOffsetLow, unsigned long dwOffsetHigh,
                                               int bImmediate);
extern unsigned long __stdcall GetTapePosition(void *hDevice, unsigned long dwPositionType,
                                               unsigned long *lpdwPartition, unsigned long *lpdwOffsetLow, unsigned long *lpdwOffsetHigh);
extern unsigned long __stdcall PrepareTape(void *hDevice, unsigned long dwOperation,
                                           int bImmediate);
extern unsigned long __stdcall EraseTape(void *hDevice, unsigned long dwEraseType,
                                         int bImmediate);
extern unsigned long __stdcall CreateTapePartition(void *hDevice,
                                                   unsigned long dwPartitionMethod, unsigned long dwCount, unsigned long dwSize);
extern unsigned long __stdcall WriteTapemark(void *hDevice, unsigned long dwTapemarkType,
                                             unsigned long dwTapemarkCount, int bImmediate);
extern unsigned long __stdcall GetTapeStatus(void *hDevice);
extern unsigned long __stdcall GetTapeParameters(void *hDevice,
                                                 unsigned long dwOperation, unsigned long *lpdwSize, void *lpTapeInformation);
extern unsigned long __stdcall SetTapeParameters(void *hDevice,
                                                 unsigned long dwOperation, void *lpTapeInformation);
extern int __stdcall Beep(unsigned long dwFreq, unsigned long dwDuration);
extern int __stdcall MulDiv(int nNumber, int nNumerator, int nDenominator);
extern void __stdcall GetSystemTime(struct _SYSTEMTIME *lpSystemTime);
extern int __stdcall SetSystemTime(const struct _SYSTEMTIME *lpSystemTime);
extern void __stdcall GetLocalTime(struct _SYSTEMTIME *lpSystemTime);
extern int __stdcall SetLocalTime(const struct _SYSTEMTIME *lpSystemTime);
extern void __stdcall GetSystemInfo(struct _SYSTEM_INFO *lpSystemInfo);
extern int __stdcall SystemTimeToTzSpecificLocalTime(struct _TIME_ZONE_INFORMATION *lpTimeZoneInformation,
                                                     struct _SYSTEMTIME *lpUniversalTime, struct _SYSTEMTIME *lpLocalTime);
extern unsigned long __stdcall GetTimeZoneInformation(struct _TIME_ZONE_INFORMATION *lpTimeZoneInformation);
extern int __stdcall SetTimeZoneInformation(const struct _TIME_ZONE_INFORMATION *lpTimeZoneInformation);
extern int __stdcall SystemTimeToFileTime(const struct _SYSTEMTIME *lpSystemTime,
                                          struct _FILETIME *lpFileTime);
extern int __stdcall FileTimeToLocalFileTime(const struct _FILETIME *lpFileTime,
                                             struct _FILETIME *lpLocalFileTime);
extern int __stdcall LocalFileTimeToFileTime(const struct _FILETIME *lpLocalFileTime,
                                             struct _FILETIME *lpFileTime);
extern int __stdcall FileTimeToSystemTime(const struct _FILETIME *lpFileTime,
                                          struct _SYSTEMTIME *lpSystemTime);
extern long __stdcall CompareFileTime(const struct _FILETIME *lpFileTime1,
                                      const struct _FILETIME *lpFileTime2);
extern int __stdcall FileTimeToDosDateTime(const struct _FILETIME *lpFileTime,
                                           unsigned short *lpFatDate, unsigned short *lpFatTime);
extern int __stdcall DosDateTimeToFileTime(unsigned short wFatDate,
                                           unsigned short wFatTime, struct _FILETIME *lpFileTime);
extern unsigned long __stdcall GetTickCount(void);
extern int __stdcall SetSystemTimeAdjustment(unsigned long dwTimeAdjustment,
                                             int bTimeAdjustmentDisabled);
extern int __stdcall GetSystemTimeAdjustment(unsigned long *lpTimeAdjustment,
                                             unsigned long *lpTimeIncrement, int *lpTimeAdjustmentDisabled);
extern unsigned long __stdcall FormatMessageA(unsigned long dwFlags,
                                              const void *lpSource, unsigned long dwMessageId, unsigned long dwLanguageId,
                                              char *lpBuffer, unsigned long nSize, char **Arguments);
extern unsigned long __stdcall FormatMessageW(unsigned long dwFlags,
                                              const void *lpSource, unsigned long dwMessageId, unsigned long dwLanguageId,
                                              char *lpBuffer, unsigned long nSize, char **Arguments);
extern int __stdcall CreatePipe(void **hReadPipe, void **hWritePipe,
                                struct _SECURITY_ATTRIBUTES *lpPipeAttributes, unsigned long nSize);
extern int __stdcall ConnectNamedPipe(void *hNamedPipe, struct _OVERLAPPED *lpOverlapped);
extern int __stdcall DisconnectNamedPipe(void *hNamedPipe);
extern int __stdcall SetNamedPipeHandleState(void *hNamedPipe,
                                             unsigned long *lpMode, unsigned long *lpMaxCollectionCount, unsigned long *lpCollectDataTimeout);
extern int __stdcall GetNamedPipeInfo(void *hNamedPipe, unsigned long *lpFlags,
                                      unsigned long *lpOutBufferSize, unsigned long *lpInBufferSize,
                                      unsigned long *lpMaxInstances);
extern int __stdcall PeekNamedPipe(void *hNamedPipe, void *lpBuffer,
                                   unsigned long nBufferSize, unsigned long *lpBytesRead, unsigned long *lpTotalBytesAvail,
                                   unsigned long *lpBytesLeftThisMessage);
extern int __stdcall TransactNamedPipe(void *hNamedPipe, void *lpInBuffer,
                                       unsigned long nInBufferSize, void *lpOutBuffer, unsigned long nOutBufferSize,
                                       unsigned long *lpBytesRead, struct _OVERLAPPED *lpOverlapped);
extern void *__stdcall CreateMailslotA(const char *lpName, unsigned long nMaxMessageSize,
                                       unsigned long lReadTimeout, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern void *__stdcall CreateMailslotW(const char *lpName, unsigned long nMaxMessageSize,
                                       unsigned long lReadTimeout, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern int __stdcall GetMailslotInfo(void *hMailslot, unsigned long *lpMaxMessageSize,
                                     unsigned long *lpNextSize, unsigned long *lpMessageCount, unsigned long *lpReadTimeout);
extern int __stdcall SetMailslotInfo(void *hMailslot, unsigned long lReadTimeout);
extern void *__stdcall MapViewOfFile(void *hFileMappingObject,
                                     unsigned long dwDesiredAccess, unsigned long dwFileOffsetHigh,
                                     unsigned long dwFileOffsetLow, unsigned long dwNumberOfBytesToMap);
extern int __stdcall FlushViewOfFile(const void *lpBaseAddress,
                                     unsigned long dwNumberOfBytesToFlush);
extern int __stdcall UnmapViewOfFile(const void *lpBaseAddress);
extern int __stdcall lstrcmpA(const char *lpString1, const char *lpString2);
extern int __stdcall lstrcmpW(const char *lpString1, const char *lpString2);
extern int __stdcall lstrcmpiA(const char *lpString1, const char *lpString2);
extern int __stdcall lstrcmpiW(const char *lpString1, const char *lpString2);
extern char *__stdcall lstrcpynA(char *lpString1, const char *lpString2,
                                 int iMaxLength);
extern char *__stdcall lstrcpynW(char *lpString1, const char *lpString2,
                                 int iMaxLength);
extern char *__stdcall lstrcpyA(char *lpString1, const char *lpString2);
extern char *__stdcall lstrcpyW(char *lpString1, const char *lpString2);
extern char *__stdcall lstrcatA(char *lpString1, const char *lpString2);
extern char *__stdcall lstrcatW(char *lpString1, const char *lpString2);
extern int __stdcall lstrlenA(const char *lpString);
extern int __stdcall lstrlenW(const char *lpString);
extern int __stdcall OpenFile(const char *lpFileName, struct _OFSTRUCT *lpReOpenBuff,
                              unsigned int uStyle);
extern int __stdcall _lopen(const char *lpPathName, int iReadWrite);
extern int __stdcall _lcreat(const char *lpPathName, int iAttribute);
extern unsigned int __stdcall _lread(int hFile, void *lpBuffer,
                                     unsigned int uBytes);
extern unsigned int __stdcall _lwrite(int hFile, const char *lpBuffer,
                                      unsigned int uBytes);
extern long __stdcall _hread(int hFile, void *lpBuffer, long lBytes);
extern long __stdcall _hwrite(int hFile, const char *lpBuffer,
                              long lBytes);
extern int __stdcall _lclose(int hFile);
extern long __stdcall _llseek(int hFile, long lOffset, int iOrigin);
extern unsigned long __stdcall TlsAlloc(void);
extern void *__stdcall TlsGetValue(unsigned long dwTlsIndex);
extern int __stdcall TlsSetValue(unsigned long dwTlsIndex, void *lpTlsValue);
extern int __stdcall TlsFree(unsigned long dwTlsIndex);
extern unsigned long __stdcall SleepEx(unsigned long dwMilliseconds,
                                       int bAlertable);
extern unsigned long __stdcall WaitForSingleObjectEx(void *hHandle,
                                                     unsigned long dwMilliseconds, int bAlertable);
extern unsigned long __stdcall WaitForMultipleObjectsEx(unsigned long nCount,
                                                        void *const *lpHandles, int bWaitAll, unsigned long dwMilliseconds,
                                                        int bAlertable);
extern int __stdcall ReadFileEx(void *hFile, void *lpBuffer, unsigned long nNumberOfBytesToRead,
                                struct _OVERLAPPED *lpOverlapped, void (__stdcall *lpCompletionRoutine)(unsigned long dwErrorCode,
                                unsigned long dwNumberOfBytesTransfered, struct _OVERLAPPED *lpOverlapped));
extern int __stdcall WriteFileEx(void *hFile, const void *lpBuffer,
                                 unsigned long nNumberOfBytesToWrite, struct _OVERLAPPED *lpOverlapped,
                                 void (__stdcall *lpCompletionRoutine)(unsigned long dwErrorCode,
                                 unsigned long dwNumberOfBytesTransfered, struct _OVERLAPPED *lpOverlapped));
extern int __stdcall BackupRead(void *hFile, unsigned char *lpBuffer,
                                unsigned long nNumberOfBytesToRead, unsigned long *lpNumberOfBytesRead,
                                int bAbort, int bProcessSecurity, void **lpContext);
extern int __stdcall BackupSeek(void *hFile, unsigned long dwLowBytesToSeek,
                                unsigned long dwHighBytesToSeek, unsigned long *lpdwLowByteSeeked,
                                unsigned long *lpdwHighByteSeeked, void **lpContext);
extern int __stdcall BackupWrite(void *hFile, unsigned char *lpBuffer,
                                 unsigned long nNumberOfBytesToWrite, unsigned long *lpNumberOfBytesWritten,
                                 int bAbort, int bProcessSecurity, void **lpContext);
extern void *__stdcall CreateMutexA(struct _SECURITY_ATTRIBUTES *lpMutexAttributes,
                                    int bInitialOwner, const char *lpName);
extern void *__stdcall CreateMutexW(struct _SECURITY_ATTRIBUTES *lpMutexAttributes,
                                    int bInitialOwner, const char *lpName);
extern void *__stdcall OpenMutexA(unsigned long dwDesiredAccess,
                                  int bInheritHandle, const char *lpName);
extern void *__stdcall OpenMutexW(unsigned long dwDesiredAccess,
                                  int bInheritHandle, const char *lpName);
extern void *__stdcall CreateEventA(struct _SECURITY_ATTRIBUTES *lpEventAttributes,
                                    int bManualReset, int bInitialState, const char *lpName);
extern void *__stdcall CreateEventW(struct _SECURITY_ATTRIBUTES *lpEventAttributes,
                                    int bManualReset, int bInitialState, const char *lpName);
extern void *__stdcall OpenEventA(unsigned long dwDesiredAccess,
                                  int bInheritHandle, const char *lpName);
extern void *__stdcall OpenEventW(unsigned long dwDesiredAccess,
                                  int bInheritHandle, const char *lpName);
extern void *__stdcall CreateSemaphoreA(struct _SECURITY_ATTRIBUTES *lpSemaphoreAttributes,
                                        long lInitialCount, long lMaximumCount, const char *lpName);
extern void *__stdcall CreateSemaphoreW(struct _SECURITY_ATTRIBUTES *lpSemaphoreAttributes,
                                        long lInitialCount, long lMaximumCount, const char *lpName);
extern void *__stdcall OpenSemaphoreA(unsigned long dwDesiredAccess,
                                      int bInheritHandle, const char *lpName);
extern void *__stdcall OpenSemaphoreW(unsigned long dwDesiredAccess,
                                      int bInheritHandle, const char *lpName);
extern void *__stdcall CreateFileMappingA(void *hFile, struct _SECURITY_ATTRIBUTES *lpFileMappingAttributes,
                                          unsigned long flProtect, unsigned long dwMaximumSizeHigh, unsigned long dwMaximumSizeLow,
                                          const char *lpName);
extern void *__stdcall CreateFileMappingW(void *hFile, struct _SECURITY_ATTRIBUTES *lpFileMappingAttributes,
                                          unsigned long flProtect, unsigned long dwMaximumSizeHigh, unsigned long dwMaximumSizeLow,
                                          const char *lpName);
extern void *__stdcall OpenFileMappingA(unsigned long dwDesiredAccess,
                                        int bInheritHandle, const char *lpName);
extern void *__stdcall OpenFileMappingW(unsigned long dwDesiredAccess,
                                        int bInheritHandle, const char *lpName);
extern unsigned long __stdcall GetLogicalDriveStringsA(unsigned long nBufferLength,
                                                       char *lpBuffer);
extern unsigned long __stdcall GetLogicalDriveStringsW(unsigned long nBufferLength,
                                                       char *lpBuffer);
extern struct HINSTANCE__ *__stdcall LoadLibraryA(const char *lpLibFileName);
extern struct HINSTANCE__ *__stdcall LoadLibraryW(const char *lpLibFileName);
extern struct HINSTANCE__ *__stdcall LoadLibraryExA(const char *lpLibFileName,
                                                    void *hFile, unsigned long dwFlags);
extern struct HINSTANCE__ *__stdcall LoadLibraryExW(const char *lpLibFileName,
                                                    void *hFile, unsigned long dwFlags);
extern unsigned long __stdcall GetModuleFileNameA(struct HINSTANCE__ *hModule,
                                                  char *lpFilename, unsigned long nSize);
extern unsigned long __stdcall GetModuleFileNameW(struct HINSTANCE__ *hModule,
                                                  char *lpFilename, unsigned long nSize);
extern struct HINSTANCE__ *__stdcall GetModuleHandleA(const char *lpModuleName);
extern struct HINSTANCE__ *__stdcall GetModuleHandleW(const char *lpModuleName);
extern int __stdcall CreateProcessA(const char *lpApplicationName,
                                    char *lpCommandLine, struct _SECURITY_ATTRIBUTES *lpProcessAttributes,
                                    struct _SECURITY_ATTRIBUTES *lpThreadAttributes, int bInheritHandles,
                                    unsigned long dwCreationFlags, void *lpEnvironment, const char *lpCurrentDirectory,
                                    struct _STARTUPINFOA *lpStartupInfo, struct _PROCESS_INFORMATION *lpProcessInformation);
extern int __stdcall CreateProcessW(const char *lpApplicationName,
                                    char *lpCommandLine, struct _SECURITY_ATTRIBUTES *lpProcessAttributes,
                                    struct _SECURITY_ATTRIBUTES *lpThreadAttributes, int bInheritHandles,
                                    unsigned long dwCreationFlags, void *lpEnvironment, const char *lpCurrentDirectory,
                                    struct _STARTUPINFOW *lpStartupInfo, struct _PROCESS_INFORMATION *lpProcessInformation);
extern int __stdcall SetProcessShutdownParameters(unsigned long dwLevel,
                                                  unsigned long dwFlags);
extern int __stdcall GetProcessShutdownParameters(unsigned long *lpdwLevel,
                                                  unsigned long *lpdwFlags);
extern void __stdcall FatalAppExitA(unsigned int uAction, const char *lpMessageText);
extern void __stdcall FatalAppExitW(unsigned int uAction, const char *lpMessageText);
extern void __stdcall GetStartupInfoA(struct _STARTUPINFOA *lpStartupInfo);
extern void __stdcall GetStartupInfoW(struct _STARTUPINFOW *lpStartupInfo);
extern char *__stdcall GetCommandLineA(void);
extern char *__stdcall GetCommandLineW(void);
extern unsigned long __stdcall GetEnvironmentVariableA(const char *lpName,
                                                       char *lpBuffer, unsigned long nSize);
extern unsigned long __stdcall GetEnvironmentVariableW(const char *lpName,
                                                       char *lpBuffer, unsigned long nSize);
extern int __stdcall SetEnvironmentVariableA(const char *lpName,
                                             const char *lpValue);
extern int __stdcall SetEnvironmentVariableW(const char *lpName,
                                             const char *lpValue);
extern unsigned long __stdcall ExpandEnvironmentStringsA(const char *lpSrc,
                                                         char *lpDst, unsigned long nSize);
extern unsigned long __stdcall ExpandEnvironmentStringsW(const char *lpSrc,
                                                         char *lpDst, unsigned long nSize);
extern void __stdcall OutputDebugStringA(const char *lpOutputString);
extern void __stdcall OutputDebugStringW(const char *lpOutputString);
extern struct HRSRC__ *__stdcall FindResourceA(struct HINSTANCE__ *hModule,
                                               const char *lpName, const char *lpType);
extern struct HRSRC__ *__stdcall FindResourceW(struct HINSTANCE__ *hModule,
                                               const char *lpName, const char *lpType);
extern struct HRSRC__ *__stdcall FindResourceExA(struct HINSTANCE__ *hModule,
                                                 const char *lpType, const char *lpName, unsigned short wLanguage);
extern struct HRSRC__ *__stdcall FindResourceExW(struct HINSTANCE__ *hModule,
                                                 const char *lpType, const char *lpName, unsigned short wLanguage);
extern int __stdcall EnumResourceTypesA(struct HINSTANCE__ *hModule,
                                        int (__stdcall *lpEnumFunc)(struct HINSTANCE__ *hModule, char *lpType,
                                        long lParam), long lParam);
extern int __stdcall EnumResourceTypesW(struct HINSTANCE__ *hModule,
                                        int (__stdcall *lpEnumFunc)(struct HINSTANCE__ *hModule, char *lpType,
                                        long lParam), long lParam);
extern int __stdcall EnumResourceNamesA(struct HINSTANCE__ *hModule,
                                        const char *lpType, int (__stdcall *lpEnumFunc)(struct HINSTANCE__ *hModule,
                                        const char *lpType, char *lpName, long lParam), long lParam);
extern int __stdcall EnumResourceNamesW(struct HINSTANCE__ *hModule,
                                        const char *lpType, int (__stdcall *lpEnumFunc)(struct HINSTANCE__ *hModule,
                                        const char *lpType, char *lpName, long lParam), long lParam);
extern int __stdcall EnumResourceLanguagesA(struct HINSTANCE__ *hModule,
                                            const char *lpType, const char *lpName, int (__stdcall *lpEnumFunc)(struct HINSTANCE__ *hModule,
                                            const char *lpType, const char *lpName, unsigned short wLanguage,
                                            long lParam), long lParam);
extern int __stdcall EnumResourceLanguagesW(struct HINSTANCE__ *hModule,
                                            const char *lpType, const char *lpName, int (__stdcall *lpEnumFunc)(struct HINSTANCE__ *hModule,
                                            const char *lpType, const char *lpName, unsigned short wLanguage,
                                            long lParam), long lParam);
extern void *__stdcall BeginUpdateResourceA(const char *pFileName,
                                            int bDeleteExistingResources);
extern void *__stdcall BeginUpdateResourceW(const char *pFileName,
                                            int bDeleteExistingResources);
extern int __stdcall UpdateResourceA(void *hUpdate, const char *lpType,
                                     const char *lpName, unsigned short wLanguage, void *lpData, unsigned long cbData);
extern int __stdcall UpdateResourceW(void *hUpdate, const char *lpType,
                                     const char *lpName, unsigned short wLanguage, void *lpData, unsigned long cbData);
extern int __stdcall EndUpdateResourceA(void *hUpdate, int fDiscard);
extern int __stdcall EndUpdateResourceW(void *hUpdate, int fDiscard);
extern unsigned short __stdcall GlobalAddAtomA(const char *lpString);
extern unsigned short __stdcall GlobalAddAtomW(const char *lpString);
extern unsigned short __stdcall GlobalFindAtomA(const char *lpString);
extern unsigned short __stdcall GlobalFindAtomW(const char *lpString);
extern unsigned int __stdcall GlobalGetAtomNameA(unsigned short nAtom,
                                                 char *lpBuffer, int nSize);
extern unsigned int __stdcall GlobalGetAtomNameW(unsigned short nAtom,
                                                 char *lpBuffer, int nSize);
extern unsigned short __stdcall AddAtomA(const char *lpString);
extern unsigned short __stdcall AddAtomW(const char *lpString);
extern unsigned short __stdcall FindAtomA(const char *lpString);
extern unsigned short __stdcall FindAtomW(const char *lpString);
extern unsigned int __stdcall GetAtomNameA(unsigned short nAtom,
                                           char *lpBuffer, int nSize);
extern unsigned int __stdcall GetAtomNameW(unsigned short nAtom,
                                           char *lpBuffer, int nSize);
extern unsigned int __stdcall GetProfileIntA(const char *lpAppName,
                                             const char *lpKeyName, int nDefault);
extern unsigned int __stdcall GetProfileIntW(const char *lpAppName,
                                             const char *lpKeyName, int nDefault);
extern unsigned long __stdcall GetProfileStringA(const char *lpAppName,
                                                 const char *lpKeyName, const char *lpDefault, char *lpReturnedString,
                                                 unsigned long nSize);
extern unsigned long __stdcall GetProfileStringW(const char *lpAppName,
                                                 const char *lpKeyName, const char *lpDefault, char *lpReturnedString,
                                                 unsigned long nSize);
extern int __stdcall WriteProfileStringA(const char *lpAppName,
                                         const char *lpKeyName, const char *lpString);
extern int __stdcall WriteProfileStringW(const char *lpAppName,
                                         const char *lpKeyName, const char *lpString);
extern unsigned long __stdcall GetProfileSectionA(const char *lpAppName,
                                                  char *lpReturnedString, unsigned long nSize);
extern unsigned long __stdcall GetProfileSectionW(const char *lpAppName,
                                                  char *lpReturnedString, unsigned long nSize);
extern int __stdcall WriteProfileSectionA(const char *lpAppName,
                                          const char *lpString);
extern int __stdcall WriteProfileSectionW(const char *lpAppName,
                                          const char *lpString);
extern unsigned int __stdcall GetPrivateProfileIntA(const char *lpAppName,
                                                    const char *lpKeyName, int nDefault, const char *lpFileName);
extern unsigned int __stdcall GetPrivateProfileIntW(const char *lpAppName,
                                                    const char *lpKeyName, int nDefault, const char *lpFileName);
extern unsigned long __stdcall GetPrivateProfileStringA(const char *lpAppName,
                                                        const char *lpKeyName, const char *lpDefault, char *lpReturnedString,
                                                        unsigned long nSize, const char *lpFileName);
extern unsigned long __stdcall GetPrivateProfileStringW(const char *lpAppName,
                                                        const char *lpKeyName, const char *lpDefault, char *lpReturnedString,
                                                        unsigned long nSize, const char *lpFileName);
extern int __stdcall WritePrivateProfileStringA(const char *lpAppName,
                                                const char *lpKeyName, const char *lpString, const char *lpFileName);
extern int __stdcall WritePrivateProfileStringW(const char *lpAppName,
                                                const char *lpKeyName, const char *lpString, const char *lpFileName);
extern unsigned long __stdcall GetPrivateProfileSectionA(const char *lpAppName,
                                                         char *lpReturnedString, unsigned long nSize, const char *lpFileName);
extern unsigned long __stdcall GetPrivateProfileSectionW(const char *lpAppName,
                                                         char *lpReturnedString, unsigned long nSize, const char *lpFileName);
extern int __stdcall WritePrivateProfileSectionA(const char *lpAppName,
                                                 const char *lpString, const char *lpFileName);
extern int __stdcall WritePrivateProfileSectionW(const char *lpAppName,
                                                 const char *lpString, const char *lpFileName);
extern unsigned int __stdcall GetDriveTypeA(const char *lpRootPathName);
extern unsigned int __stdcall GetDriveTypeW(const char *lpRootPathName);
extern unsigned int __stdcall GetSystemDirectoryA(char *lpBuffer,
                                                  unsigned int uSize);
extern unsigned int __stdcall GetSystemDirectoryW(char *lpBuffer,
                                                  unsigned int uSize);
extern unsigned long __stdcall GetTempPathA(unsigned long nBufferLength,
                                            char *lpBuffer);
extern unsigned long __stdcall GetTempPathW(unsigned long nBufferLength,
                                            char *lpBuffer);
extern unsigned int __stdcall GetTempFileNameA(const char *lpPathName,
                                               const char *lpPrefixString, unsigned int uUnique, char *lpTempFileName);
extern unsigned int __stdcall GetTempFileNameW(const char *lpPathName,
                                               const char *lpPrefixString, unsigned int uUnique, char *lpTempFileName);
extern unsigned int __stdcall GetWindowsDirectoryA(char *lpBuffer,
                                                   unsigned int uSize);
extern unsigned int __stdcall GetWindowsDirectoryW(char *lpBuffer,
                                                   unsigned int uSize);
extern int __stdcall SetCurrentDirectoryA(const char *lpPathName);
extern int __stdcall SetCurrentDirectoryW(const char *lpPathName);
extern unsigned long __stdcall GetCurrentDirectoryA(unsigned long nBufferLength,
                                                    char *lpBuffer);
extern unsigned long __stdcall GetCurrentDirectoryW(unsigned long nBufferLength,
                                                    char *lpBuffer);
extern int __stdcall GetDiskFreeSpaceA(const char *lpRootPathName,
                                       unsigned long *lpSectorsPerCluster, unsigned long *lpBytesPerSector,
                                       unsigned long *lpNumberOfFreeClusters, unsigned long *lpTotalNumberOfClusters);
extern int __stdcall GetDiskFreeSpaceW(const char *lpRootPathName,
                                       unsigned long *lpSectorsPerCluster, unsigned long *lpBytesPerSector,
                                       unsigned long *lpNumberOfFreeClusters, unsigned long *lpTotalNumberOfClusters);
extern int __stdcall CreateDirectoryA(const char *lpPathName, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern int __stdcall CreateDirectoryW(const char *lpPathName, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern int __stdcall CreateDirectoryExA(const char *lpTemplateDirectory,
                                        const char *lpNewDirectory, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern int __stdcall CreateDirectoryExW(const char *lpTemplateDirectory,
                                        const char *lpNewDirectory, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern int __stdcall RemoveDirectoryA(const char *lpPathName);
extern int __stdcall RemoveDirectoryW(const char *lpPathName);
extern unsigned long __stdcall GetFullPathNameA(const char *lpFileName,
                                                unsigned long nBufferLength, char *lpBuffer, char **lpFilePart);
extern unsigned long __stdcall GetFullPathNameW(const char *lpFileName,
                                                unsigned long nBufferLength, char *lpBuffer, char **lpFilePart);
extern int __stdcall DefineDosDeviceA(unsigned long dwFlags, const char *lpDeviceName,
                                      const char *lpTargetPath);
extern int __stdcall DefineDosDeviceW(unsigned long dwFlags, const char *lpDeviceName,
                                      const char *lpTargetPath);
extern unsigned long __stdcall QueryDosDeviceA(const char *lpDeviceName,
                                               char *lpTargetPath, unsigned long ucchMax);
extern unsigned long __stdcall QueryDosDeviceW(const char *lpDeviceName,
                                               char *lpTargetPath, unsigned long ucchMax);
extern void *__stdcall CreateFileA(const char *lpFileName, unsigned long dwDesiredAccess,
                                   unsigned long dwShareMode, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes,
                                   unsigned long dwCreationDisposition, unsigned long dwFlagsAndAttributes,
                                   void *hTemplateFile);
extern void *__stdcall CreateFileW(const char *lpFileName, unsigned long dwDesiredAccess,
                                   unsigned long dwShareMode, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes,
                                   unsigned long dwCreationDisposition, unsigned long dwFlagsAndAttributes,
                                   void *hTemplateFile);
extern int __stdcall SetFileAttributesA(const char *lpFileName,
                                        unsigned long dwFileAttributes);
extern int __stdcall SetFileAttributesW(const char *lpFileName,
                                        unsigned long dwFileAttributes);
extern unsigned long __stdcall GetFileAttributesA(const char *lpFileName);
extern unsigned long __stdcall GetFileAttributesW(const char *lpFileName);
extern unsigned long __stdcall GetCompressedFileSizeA(const char *lpFileName,
                                                      unsigned long *lpFileSizeHigh);
extern unsigned long __stdcall GetCompressedFileSizeW(const char *lpFileName,
                                                      unsigned long *lpFileSizeHigh);
extern int __stdcall DeleteFileA(const char *lpFileName);
extern int __stdcall DeleteFileW(const char *lpFileName);
extern void *__stdcall FindFirstFileA(const char *lpFileName, struct _WIN32_FIND_DATAA *lpFindFileData);
extern void *__stdcall FindFirstFileW(const char *lpFileName, struct _WIN32_FIND_DATAW *lpFindFileData);
extern int __stdcall FindNextFileA(void *hFindFile, struct _WIN32_FIND_DATAA *lpFindFileData);
extern int __stdcall FindNextFileW(void *hFindFile, struct _WIN32_FIND_DATAW *lpFindFileData);
extern unsigned long __stdcall SearchPathA(const char *lpPath,
                                           const char *lpFileName, const char *lpExtension, unsigned long nBufferLength,
                                           char *lpBuffer, char **lpFilePart);
extern unsigned long __stdcall SearchPathW(const char *lpPath,
                                           const char *lpFileName, const char *lpExtension, unsigned long nBufferLength,
                                           char *lpBuffer, char **lpFilePart);
extern int __stdcall CopyFileA(const char *lpExistingFileName,
                               const char *lpNewFileName, int bFailIfExists);
extern int __stdcall CopyFileW(const char *lpExistingFileName,
                               const char *lpNewFileName, int bFailIfExists);
extern int __stdcall MoveFileA(const char *lpExistingFileName,
                               const char *lpNewFileName);
extern int __stdcall MoveFileW(const char *lpExistingFileName,
                               const char *lpNewFileName);
extern int __stdcall MoveFileExA(const char *lpExistingFileName,
                                 const char *lpNewFileName, unsigned long dwFlags);
extern int __stdcall MoveFileExW(const char *lpExistingFileName,
                                 const char *lpNewFileName, unsigned long dwFlags);
extern void *__stdcall CreateNamedPipeA(const char *lpName, unsigned long dwOpenMode,
                                        unsigned long dwPipeMode, unsigned long nMaxInstances, unsigned long nOutBufferSize,
                                        unsigned long nInBufferSize, unsigned long nDefaultTimeOut, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern void *__stdcall CreateNamedPipeW(const char *lpName, unsigned long dwOpenMode,
                                        unsigned long dwPipeMode, unsigned long nMaxInstances, unsigned long nOutBufferSize,
                                        unsigned long nInBufferSize, unsigned long nDefaultTimeOut, struct _SECURITY_ATTRIBUTES *lpSecurityAttributes);
extern int __stdcall GetNamedPipeHandleStateA(void *hNamedPipe,
                                              unsigned long *lpState, unsigned long *lpCurInstances, unsigned long *lpMaxCollectionCount,
                                              unsigned long *lpCollectDataTimeout, char *lpUserName, unsigned long nMaxUserNameSize);
extern int __stdcall GetNamedPipeHandleStateW(void *hNamedPipe,
                                              unsigned long *lpState, unsigned long *lpCurInstances, unsigned long *lpMaxCollectionCount,
                                              unsigned long *lpCollectDataTimeout, char *lpUserName, unsigned long nMaxUserNameSize);
extern int __stdcall CallNamedPipeA(const char *lpNamedPipeName,
                                    void *lpInBuffer, unsigned long nInBufferSize, void *lpOutBuffer,
                                    unsigned long nOutBufferSize, unsigned long *lpBytesRead, unsigned long nTimeOut);
extern int __stdcall CallNamedPipeW(const char *lpNamedPipeName,
                                    void *lpInBuffer, unsigned long nInBufferSize, void *lpOutBuffer,
                                    unsigned long nOutBufferSize, unsigned long *lpBytesRead, unsigned long nTimeOut);
extern int __stdcall WaitNamedPipeA(const char *lpNamedPipeName,
                                    unsigned long nTimeOut);
extern int __stdcall WaitNamedPipeW(const char *lpNamedPipeName,
                                    unsigned long nTimeOut);
extern int __stdcall SetVolumeLabelA(const char *lpRootPathName,
                                     const char *lpVolumeName);
extern int __stdcall SetVolumeLabelW(const char *lpRootPathName,
                                     const char *lpVolumeName);
extern void __stdcall SetFileApisToOEM(void);
extern void __stdcall SetFileApisToANSI(void);
extern int __stdcall AreFileApisANSI(void);
extern int __stdcall GetVolumeInformationA(const char *lpRootPathName,
                                           char *lpVolumeNameBuffer, unsigned long nVolumeNameSize, unsigned long *lpVolumeSerialNumber,
                                           unsigned long *lpMaximumComponentLength, unsigned long *lpFileSystemFlags,
                                           char *lpFileSystemNameBuffer, unsigned long nFileSystemNameSize);
extern int __stdcall GetVolumeInformationW(const char *lpRootPathName,
                                           char *lpVolumeNameBuffer, unsigned long nVolumeNameSize, unsigned long *lpVolumeSerialNumber,
                                           unsigned long *lpMaximumComponentLength, unsigned long *lpFileSystemFlags,
                                           char *lpFileSystemNameBuffer, unsigned long nFileSystemNameSize);
extern void *__stdcall FindFirstChangeNotificationA(const char *lpPathName,
                                                    int bWatchSubtree, unsigned long dwNotifyFilter);
extern void *__stdcall FindFirstChangeNotificationW(const char *lpPathName,
                                                    int bWatchSubtree, unsigned long dwNotifyFilter);
extern int __stdcall FindNextChangeNotification(void *hChangeHandle);
extern int __stdcall FindCloseChangeNotification(void *hChangeHandle);
extern int __stdcall VirtualLock(void *lpAddress, unsigned long dwSize);
extern int __stdcall VirtualUnlock(void *lpAddress, unsigned long dwSize);
extern void *__stdcall MapViewOfFileEx(void *hFileMappingObject,
                                       unsigned long dwDesiredAccess, unsigned long dwFileOffsetHigh,
                                       unsigned long dwFileOffsetLow, unsigned long dwNumberOfBytesToMap,
                                       void *lpBaseAddress);
extern int __stdcall SetPriorityClass(void *hProcess, unsigned long dwPriorityClass);
extern unsigned long __stdcall GetPriorityClass(void *hProcess);
extern int __stdcall IsBadReadPtr(const void *lp, unsigned int ucb);
extern int __stdcall IsBadWritePtr(void *lp, unsigned int ucb);
extern int __stdcall IsBadHugeReadPtr(const void *lp, unsigned int ucb);
extern int __stdcall IsBadHugeWritePtr(void *lp, unsigned int ucb);
extern int __stdcall IsBadCodePtr(int (__stdcall *lpfn)(void));
extern int __stdcall IsBadStringPtrA(const char *lpsz, unsigned int ucchMax);
extern int __stdcall IsBadStringPtrW(const char *lpsz, unsigned int ucchMax);
extern int __stdcall BuildCommDCBA(const char *lpDef, struct _DCB *lpDCB);
extern int __stdcall BuildCommDCBW(const char *lpDef, struct _DCB *lpDCB);
extern int __stdcall BuildCommDCBAndTimeoutsA(const char *lpDef,
                                              struct _DCB *lpDCB, struct _COMMTIMEOUTS *lpCommTimeouts);
extern int __stdcall BuildCommDCBAndTimeoutsW(const char *lpDef,
                                              struct _DCB *lpDCB, struct _COMMTIMEOUTS *lpCommTimeouts);
extern int __stdcall CommConfigDialogA(const char *lpszName, struct HWND__ *hWnd,
                                       struct _COMMCONFIG *lpCC);
extern int __stdcall CommConfigDialogW(const char *lpszName, struct HWND__ *hWnd,
                                       struct _COMMCONFIG *lpCC);
extern int __stdcall GetDefaultCommConfigA(const char *lpszName,
                                           struct _COMMCONFIG *lpCC, unsigned long *lpdwSize);
extern int __stdcall GetDefaultCommConfigW(const char *lpszName,
                                           struct _COMMCONFIG *lpCC, unsigned long *lpdwSize);
extern int __stdcall SetDefaultCommConfigA(const char *lpszName,
                                           struct _COMMCONFIG *lpCC, unsigned long dwSize);
extern int __stdcall SetDefaultCommConfigW(const char *lpszName,
                                           struct _COMMCONFIG *lpCC, unsigned long dwSize);
extern int __stdcall GetComputerNameA(char *lpBuffer, unsigned long *nSize);
extern int __stdcall GetComputerNameW(char *lpBuffer, unsigned long *nSize);
extern int __stdcall SetComputerNameA(const char *lpComputerName);
extern int __stdcall SetComputerNameW(const char *lpComputerName);
extern int __stdcall QueryPerformanceCounter(union _LARGE_INTEGER *lpPerformanceCount);
extern int __stdcall QueryPerformanceFrequency(union _LARGE_INTEGER *lpFrequency);
extern int __stdcall GetVersionExA(struct _OSVERSIONINFOA *lpVersionInformation);
extern int __stdcall GetVersionExW(struct _OSVERSIONINFOW *lpVersionInformation);
extern int __stdcall IsValidCodePage(unsigned int CodePage);
extern unsigned int __stdcall GetACP(void);
extern unsigned int __stdcall GetOEMCP(void);
extern int __stdcall GetCPInfo(unsigned int CodePage, struct _cpinfo *lpCPInfo);
extern int __stdcall IsDBCSLeadByte(unsigned char TestChar);
extern int __stdcall IsDBCSLeadByteEx(unsigned int CodePage, unsigned char TestChar);
extern int __stdcall MultiByteToWideChar(unsigned int CodePage,
                                         unsigned long dwFlags, const char *lpMultiByteStr, int cchMultiByte,
                                         char *lpWideCharStr, int cchWideChar);
extern int __stdcall WideCharToMultiByte(unsigned int CodePage,
                                         unsigned long dwFlags, const char *lpWideCharStr, int cchWideChar,
                                         char *lpMultiByteStr, int cchMultiByte, const char *lpDefaultChar,
                                         int *lpUsedDefaultChar);
extern int __stdcall CompareStringA(unsigned long Locale, unsigned long dwCmpFlags,
                                    const char *lpString1, int cchCount1, const char *lpString2, int cchCount2);
extern int __stdcall CompareStringW(unsigned long Locale, unsigned long dwCmpFlags,
                                    const char *lpString1, int cchCount1, const char *lpString2, int cchCount2);
extern int __stdcall LCMapStringA(unsigned long Locale, unsigned long dwMapFlags,
                                  const char *lpSrcStr, int cchSrc, char *lpDestStr, int cchDest);
extern int __stdcall LCMapStringW(unsigned long Locale, unsigned long dwMapFlags,
                                  const char *lpSrcStr, int cchSrc, char *lpDestStr, int cchDest);
extern int __stdcall GetLocaleInfoA(unsigned long Locale, unsigned long LCType,
                                    char *lpLCData, int cchData);
extern int __stdcall GetLocaleInfoW(unsigned long Locale, unsigned long LCType,
                                    char *lpLCData, int cchData);
extern int __stdcall SetLocaleInfoA(unsigned long Locale, unsigned long LCType,
                                    const char *lpLCData);
extern int __stdcall SetLocaleInfoW(unsigned long Locale, unsigned long LCType,
                                    const char *lpLCData);
extern int __stdcall GetTimeFormatA(unsigned long Locale, unsigned long dwFlags,
                                    const struct _SYSTEMTIME *lpTime, const char *lpFormat, char *lpTimeStr,
                                    int cchTime);
extern int __stdcall GetTimeFormatW(unsigned long Locale, unsigned long dwFlags,
                                    const struct _SYSTEMTIME *lpTime, const char *lpFormat, char *lpTimeStr,
                                    int cchTime);
extern int __stdcall GetDateFormatA(unsigned long Locale, unsigned long dwFlags,
                                    const struct _SYSTEMTIME *lpDate, const char *lpFormat, char *lpDateStr,
                                    int cchDate);
extern int __stdcall GetDateFormatW(unsigned long Locale, unsigned long dwFlags,
                                    const struct _SYSTEMTIME *lpDate, const char *lpFormat, char *lpDateStr,
                                    int cchDate);
extern int __stdcall GetNumberFormatA(unsigned long Locale, unsigned long dwFlags,
                                      const char *lpValue, const struct _numberfmtA *lpFormat, char *lpNumberStr,
                                      int cchNumber);
extern int __stdcall GetNumberFormatW(unsigned long Locale, unsigned long dwFlags,
                                      const char *lpValue, const struct _numberfmtW *lpFormat, char *lpNumberStr,
                                      int cchNumber);
extern int __stdcall GetCurrencyFormatA(unsigned long Locale, unsigned long dwFlags,
                                        const char *lpValue, const struct _currencyfmtA *lpFormat, char *lpCurrencyStr,
                                        int cchCurrency);
extern int __stdcall GetCurrencyFormatW(unsigned long Locale, unsigned long dwFlags,
                                        const char *lpValue, const struct _currencyfmtW *lpFormat, char *lpCurrencyStr,
                                        int cchCurrency);
extern int __stdcall EnumCalendarInfoA(int (__stdcall *lpCalInfoEnumProc)(char *),
                                       unsigned long Locale, unsigned long Calendar, unsigned long CalType);
extern int __stdcall EnumCalendarInfoW(int (__stdcall *lpCalInfoEnumProc)(char *),
                                       unsigned long Locale, unsigned long Calendar, unsigned long CalType);
extern int __stdcall EnumTimeFormatsA(int (__stdcall *lpTimeFmtEnumProc)(char *),
                                      unsigned long Locale, unsigned long dwFlags);
extern int __stdcall EnumTimeFormatsW(int (__stdcall *lpTimeFmtEnumProc)(char *),
                                      unsigned long Locale, unsigned long dwFlags);
extern int __stdcall EnumDateFormatsA(int (__stdcall *lpDateFmtEnumProc)(char *),
                                      unsigned long Locale, unsigned long dwFlags);
extern int __stdcall EnumDateFormatsW(int (__stdcall *lpDateFmtEnumProc)(char *),
                                      unsigned long Locale, unsigned long dwFlags);
extern int __stdcall IsValidLocale(unsigned long Locale, unsigned long dwFlags);
extern unsigned long __stdcall ConvertDefaultLocale(unsigned long Locale);
extern unsigned long __stdcall GetThreadLocale(void);
extern int __stdcall SetThreadLocale(unsigned long Locale);
extern unsigned short __stdcall GetSystemDefaultLangID(void);
extern unsigned short __stdcall GetUserDefaultLangID(void);
extern unsigned long __stdcall GetSystemDefaultLCID(void);
extern unsigned long __stdcall GetUserDefaultLCID(void);
extern int __stdcall GetStringTypeExA(unsigned long Locale, unsigned long dwInfoType,
                                      const char *lpSrcStr, int cchSrc, unsigned short *lpCharType);
extern int __stdcall GetStringTypeExW(unsigned long Locale, unsigned long dwInfoType,
                                      const char *lpSrcStr, int cchSrc, unsigned short *lpCharType);
extern int __stdcall GetStringTypeA(unsigned long Locale, unsigned long dwInfoType,
                                    const char *lpSrcStr, int cchSrc, unsigned short *lpCharType);
extern int __stdcall GetStringTypeW(unsigned long dwInfoType, const char *lpSrcStr,
                                    int cchSrc, unsigned short *lpCharType);
extern int __stdcall FoldStringA(unsigned long dwMapFlags, const char *lpSrcStr,
                                 int cchSrc, char *lpDestStr, int cchDest);
extern int __stdcall FoldStringW(unsigned long dwMapFlags, const char *lpSrcStr,
                                 int cchSrc, char *lpDestStr, int cchDest);
extern int __stdcall EnumSystemLocalesA(int (__stdcall *lpLocaleEnumProc)(char *),
                                        unsigned long dwFlags);
extern int __stdcall EnumSystemLocalesW(int (__stdcall *lpLocaleEnumProc)(char *),
                                        unsigned long dwFlags);
extern int __stdcall EnumSystemCodePagesA(int (__stdcall *lpCodePageEnumProc)(char *),
                                          unsigned long dwFlags);
extern int __stdcall EnumSystemCodePagesW(int (__stdcall *lpCodePageEnumProc)(char *),
                                          unsigned long dwFlags);
extern int __stdcall PeekConsoleInputA(void *hConsoleInput, struct _INPUT_RECORD *lpBuffer,
                                       unsigned long nLength, unsigned long *lpNumberOfEventsRead);
extern int __stdcall PeekConsoleInputW(void *hConsoleInput, struct _INPUT_RECORD *lpBuffer,
                                       unsigned long nLength, unsigned long *lpNumberOfEventsRead);
extern int __stdcall ReadConsoleInputA(void *hConsoleInput, struct _INPUT_RECORD *lpBuffer,
                                       unsigned long nLength, unsigned long *lpNumberOfEventsRead);
extern int __stdcall ReadConsoleInputW(void *hConsoleInput, struct _INPUT_RECORD *lpBuffer,
                                       unsigned long nLength, unsigned long *lpNumberOfEventsRead);
extern int __stdcall WriteConsoleInputA(void *hConsoleInput, const struct _INPUT_RECORD *lpBuffer,
                                        unsigned long nLength, unsigned long *lpNumberOfEventsWritten);
extern int __stdcall WriteConsoleInputW(void *hConsoleInput, const struct _INPUT_RECORD *lpBuffer,
                                        unsigned long nLength, unsigned long *lpNumberOfEventsWritten);
extern int __stdcall ReadConsoleOutputA(void *hConsoleOutput, struct _CHAR_INFO *lpBuffer,
                                        struct _COORD dwBufferSize, struct _COORD dwBufferCoord, struct _SMALL_RECT *lpReadRegion);
extern int __stdcall ReadConsoleOutputW(void *hConsoleOutput, struct _CHAR_INFO *lpBuffer,
                                        struct _COORD dwBufferSize, struct _COORD dwBufferCoord, struct _SMALL_RECT *lpReadRegion);
extern int __stdcall WriteConsoleOutputA(void *hConsoleOutput,
                                         const struct _CHAR_INFO *lpBuffer, struct _COORD dwBufferSize,
                                         struct _COORD dwBufferCoord, struct _SMALL_RECT *lpWriteRegion);
extern int __stdcall WriteConsoleOutputW(void *hConsoleOutput,
                                         const struct _CHAR_INFO *lpBuffer, struct _COORD dwBufferSize,
                                         struct _COORD dwBufferCoord, struct _SMALL_RECT *lpWriteRegion);
extern int __stdcall ReadConsoleOutputCharacterA(void *hConsoleOutput,
                                                 char *lpCharacter, unsigned long nLength, struct _COORD dwReadCoord,
                                                 unsigned long *lpNumberOfCharsRead);
extern int __stdcall ReadConsoleOutputCharacterW(void *hConsoleOutput,
                                                 char *lpCharacter, unsigned long nLength, struct _COORD dwReadCoord,
                                                 unsigned long *lpNumberOfCharsRead);
extern int __stdcall ReadConsoleOutputAttribute(void *hConsoleOutput,
                                                unsigned short *lpAttribute, unsigned long nLength, struct _COORD dwReadCoord,
                                                unsigned long *lpNumberOfAttrsRead);
extern int __stdcall WriteConsoleOutputCharacterA(void *hConsoleOutput,
                                                  const char *lpCharacter, unsigned long nLength, struct _COORD dwWriteCoord,
                                                  unsigned long *lpNumberOfCharsWritten);
extern int __stdcall WriteConsoleOutputCharacterW(void *hConsoleOutput,
                                                  const char *lpCharacter, unsigned long nLength, struct _COORD dwWriteCoord,
                                                  unsigned long *lpNumberOfCharsWritten);
extern int __stdcall WriteConsoleOutputAttribute(void *hConsoleOutput,
                                                 const unsigned short *lpAttribute, unsigned long nLength, struct _COORD dwWriteCoord,
                                                 unsigned long *lpNumberOfAttrsWritten);
extern int __stdcall FillConsoleOutputCharacterA(void *hConsoleOutput,
                                                 char cCharacter, unsigned long nLength, struct _COORD dwWriteCoord,
                                                 unsigned long *lpNumberOfCharsWritten);
extern int __stdcall FillConsoleOutputCharacterW(void *hConsoleOutput,
                                                 char cCharacter, unsigned long nLength, struct _COORD dwWriteCoord,
                                                 unsigned long *lpNumberOfCharsWritten);
extern int __stdcall FillConsoleOutputAttribute(void *hConsoleOutput,
                                                unsigned short wAttribute, unsigned long nLength, struct _COORD dwWriteCoord,
                                                unsigned long *lpNumberOfAttrsWritten);
extern int __stdcall GetConsoleMode(void *hConsoleHandle, unsigned long *lpMode);
extern int __stdcall GetNumberOfConsoleInputEvents(void *hConsoleInput,
                                                   unsigned long *lpNumberOfEvents);
extern int __stdcall GetConsoleScreenBufferInfo(void *hConsoleOutput,
                                                struct _CONSOLE_SCREEN_BUFFER_INFO *lpConsoleScreenBufferInfo);
extern struct _COORD __stdcall GetLargestConsoleWindowSize(void *hConsoleOutput);
extern int __stdcall GetConsoleCursorInfo(void *hConsoleOutput,
                                          struct _CONSOLE_CURSOR_INFO *lpConsoleCursorInfo);
extern int __stdcall GetNumberOfConsoleMouseButtons(unsigned long *lpNumberOfMouseButtons);
extern int __stdcall SetConsoleMode(void *hConsoleHandle, unsigned long dwMode);
extern int __stdcall SetConsoleActiveScreenBuffer(void *hConsoleOutput);
extern int __stdcall FlushConsoleInputBuffer(void *hConsoleInput);
extern int __stdcall SetConsoleScreenBufferSize(void *hConsoleOutput,
                                                struct _COORD dwSize);
extern int __stdcall SetConsoleCursorPosition(void *hConsoleOutput,
                                              struct _COORD dwCursorPosition);
extern int __stdcall SetConsoleCursorInfo(void *hConsoleOutput,
                                          const struct _CONSOLE_CURSOR_INFO *lpConsoleCursorInfo);
extern int __stdcall ScrollConsoleScreenBufferA(void *hConsoleOutput,
                                                const struct _SMALL_RECT *lpScrollRectangle, const struct _SMALL_RECT *lpClipRectangle,
                                                struct _COORD dwDestinationOrigin, const struct _CHAR_INFO *lpFill);
extern int __stdcall ScrollConsoleScreenBufferW(void *hConsoleOutput,
                                                const struct _SMALL_RECT *lpScrollRectangle, const struct _SMALL_RECT *lpClipRectangle,
                                                struct _COORD dwDestinationOrigin, const struct _CHAR_INFO *lpFill);
extern int __stdcall SetConsoleWindowInfo(void *hConsoleOutput,
                                          int bAbsolute, const struct _SMALL_RECT *lpConsoleWindow);
extern int __stdcall SetConsoleTextAttribute(void *hConsoleOutput,
                                             unsigned short wAttributes);
extern int __stdcall SetConsoleCtrlHandler(int (__stdcall *HandlerRoutine)(unsigned long CtrlType),
                                           int Add);
extern int __stdcall GenerateConsoleCtrlEvent(unsigned long dwCtrlEvent,
                                              unsigned long dwProcessGroupId);
extern int __stdcall AllocConsole(void);
extern int __stdcall FreeConsole(void);
extern unsigned long __stdcall GetConsoleTitleA(char *lpConsoleTitle,
                                                unsigned long nSize);
extern unsigned long __stdcall GetConsoleTitleW(char *lpConsoleTitle,
                                                unsigned long nSize);
extern int __stdcall SetConsoleTitleA(const char *lpConsoleTitle);
extern int __stdcall SetConsoleTitleW(const char *lpConsoleTitle);
extern int __stdcall ReadConsoleA(void *hConsoleInput, void *lpBuffer,
                                  unsigned long nNumberOfCharsToRead, unsigned long *lpNumberOfCharsRead,
                                  void *lpReserved);
extern int __stdcall ReadConsoleW(void *hConsoleInput, void *lpBuffer,
                                  unsigned long nNumberOfCharsToRead, unsigned long *lpNumberOfCharsRead,
                                  void *lpReserved);
extern int __stdcall WriteConsoleA(void *hConsoleOutput, const void *lpBuffer,
                                   unsigned long nNumberOfCharsToWrite, unsigned long *lpNumberOfCharsWritten,
                                   void *lpReserved);
extern int __stdcall WriteConsoleW(void *hConsoleOutput, const void *lpBuffer,
                                   unsigned long nNumberOfCharsToWrite, unsigned long *lpNumberOfCharsWritten,
                                   void *lpReserved);
extern void *__stdcall CreateConsoleScreenBuffer(unsigned long dwDesiredAccess,
                                                 unsigned long dwShareMode, const struct _SECURITY_ATTRIBUTES *lpSecurityAttributes,
                                                 unsigned long dwFlags, void *lpScreenBufferData);
extern unsigned int __stdcall GetConsoleCP(void);
extern int __stdcall SetConsoleCP(unsigned int wCodePageID);
extern unsigned int __stdcall GetConsoleOutputCP(void);
extern int __stdcall SetConsoleOutputCP(unsigned int wCodePageID);
extern unsigned long __stdcall VerLanguageNameA(unsigned long wLang,
                                                char *szLang, unsigned long nSize);
extern unsigned long __stdcall VerLanguageNameW(unsigned long wLang,
                                                char *szLang, unsigned long nSize);
extern int __stdcall wvsprintfA(char *, const char *, char *arglist);
extern int __stdcall wvsprintfW(char *, const char *, char *arglist);
extern int __cdecl wsprintfA(char *, const char *, ...);
extern int __cdecl wsprintfW(char *, const char *, ...);
extern struct HKL__ *__stdcall LoadKeyboardLayoutA(const char *pwszKLID,
                                                   unsigned int Flags);
extern struct HKL__ *__stdcall LoadKeyboardLayoutW(const char *pwszKLID,
                                                   unsigned int Flags);
extern struct HKL__ *__stdcall ActivateKeyboardLayout(struct HKL__ *hkl,
                                                      unsigned int Flags);
extern int __stdcall UnloadKeyboardLayout(struct HKL__ *hkl);
extern int __stdcall GetKeyboardLayoutNameA(char *pwszKLID);
extern int __stdcall GetKeyboardLayoutNameW(char *pwszKLID);
extern int __stdcall GetKeyboardLayoutList(int nBuff, struct HKL__ **lpList);
extern struct HKL__ *__stdcall GetKeyboardLayout(unsigned long dwLayout);
extern struct HDESK__ *__stdcall CreateDesktopA(char *lpszDesktop,
                                                char *lpszDevice, struct _devicemodeA *pDevmode, unsigned long dwFlags,
                                                unsigned long dwDesiredAccess, struct _SECURITY_ATTRIBUTES *lpsa);
extern struct HDESK__ *__stdcall CreateDesktopW(char *lpszDesktop,
                                                char *lpszDevice, struct _devicemodeW *pDevmode, unsigned long dwFlags,
                                                unsigned long dwDesiredAccess, struct _SECURITY_ATTRIBUTES *lpsa);
extern struct HDESK__ *__stdcall OpenDesktopA(char *lpszDesktop,
                                              unsigned long dwFlags, int fInherit, unsigned long dwDesiredAccess);
extern struct HDESK__ *__stdcall OpenDesktopW(char *lpszDesktop,
                                              unsigned long dwFlags, int fInherit, unsigned long dwDesiredAccess);
extern struct HDESK__ *__stdcall OpenInputDesktop(unsigned long dwFlags,
                                                  int fInherit, unsigned long dwDesiredAccess);
extern int __stdcall EnumDesktopsA(struct HWINSTA__ *hwinsta, int (__stdcall *lpEnumFunc)(char *,
                                   long), long lParam);
extern int __stdcall EnumDesktopsW(struct HWINSTA__ *hwinsta, int (__stdcall *lpEnumFunc)(char *,
                                   long), long lParam);
extern int __stdcall SwitchDesktop(struct HDESK__ *hDesktop);
extern int __stdcall SetThreadDesktop(struct HDESK__ *hDesktop);
extern int __stdcall CloseDesktop(struct HDESK__ *hDesktop);
extern struct HDESK__ *__stdcall GetThreadDesktop(unsigned long dwThreadId);
extern struct HWINSTA__ *__stdcall CreateWindowStationA(char *lpwinsta,
                                                        unsigned long dwReserved, unsigned long dwDesiredAccess, struct _SECURITY_ATTRIBUTES *lpsa);
extern struct HWINSTA__ *__stdcall CreateWindowStationW(char *lpwinsta,
                                                        unsigned long dwReserved, unsigned long dwDesiredAccess, struct _SECURITY_ATTRIBUTES *lpsa);
extern struct HWINSTA__ *__stdcall OpenWindowStationA(char *lpszWinSta,
                                                      int fInherit, unsigned long dwDesiredAccess);
extern struct HWINSTA__ *__stdcall OpenWindowStationW(char *lpszWinSta,
                                                      int fInherit, unsigned long dwDesiredAccess);
extern int __stdcall EnumWindowStationsA(int (__stdcall *lpEnumFunc)(char *,
                                         long), long lParam);
extern int __stdcall EnumWindowStationsW(int (__stdcall *lpEnumFunc)(char *,
                                         long), long lParam);
extern int __stdcall CloseWindowStation(struct HWINSTA__ *hWinSta);
extern int __stdcall SetProcessWindowStation(struct HWINSTA__ *hWinSta);
extern struct HWINSTA__ *__stdcall GetProcessWindowStation(void);
extern int __stdcall SetUserObjectSecurity(void *hObj, unsigned long *pSIRequested,
                                           void *pSID);
extern int __stdcall GetUserObjectSecurity(void *hObj, unsigned long *pSIRequested,
                                           void *pSID, unsigned long nLength, unsigned long *lpnLengthNeeded);
extern int __stdcall GetUserObjectInformationA(void *hObj, int nIndex,
                                               void *pvInfo, unsigned long nLength, unsigned long *lpnLengthNeeded);
extern int __stdcall GetUserObjectInformationW(void *hObj, int nIndex,
                                               void *pvInfo, unsigned long nLength, unsigned long *lpnLengthNeeded);
extern int __stdcall SetUserObjectInformationA(void *hObj, int nIndex,
                                               void *pvInfo, unsigned long nLength);
extern int __stdcall SetUserObjectInformationW(void *hObj, int nIndex,
                                               void *pvInfo, unsigned long nLength);
extern unsigned int __stdcall RegisterWindowMessageA(const char *lpString);
extern unsigned int __stdcall RegisterWindowMessageW(const char *lpString);
extern int __stdcall DrawEdge(struct HDC__ *hdc, struct tagRECT *qrc,
                              unsigned int edge, unsigned int grfFlags);
extern int __stdcall DrawFrameControl(struct HDC__ *, struct tagRECT *,
                                      unsigned int, unsigned int);
extern int __stdcall DrawCaption(struct HWND__ *, struct HDC__ *,
                                 const struct tagRECT *, unsigned int);
extern int __stdcall DrawAnimatedRects(struct HWND__ *hwnd, int idAni,
                                       const struct tagRECT *lprcFrom, const struct tagRECT *lprcTo);
extern int __stdcall GetMessageA(struct tagMSG *lpMsg, struct HWND__ *hWnd,
                                 unsigned int wMsgFilterMin, unsigned int wMsgFilterMax);
extern int __stdcall GetMessageW(struct tagMSG *lpMsg, struct HWND__ *hWnd,
                                 unsigned int wMsgFilterMin, unsigned int wMsgFilterMax);
extern int __stdcall TranslateMessage(const struct tagMSG *lpMsg);
extern long __stdcall DispatchMessageA(const struct tagMSG *lpMsg);
extern long __stdcall DispatchMessageW(const struct tagMSG *lpMsg);
extern int __stdcall SetMessageQueue(int cMessagesMax);
extern int __stdcall PeekMessageA(struct tagMSG *lpMsg, struct HWND__ *hWnd,
                                  unsigned int wMsgFilterMin, unsigned int wMsgFilterMax, unsigned int wRemoveMsg);
extern int __stdcall PeekMessageW(struct tagMSG *lpMsg, struct HWND__ *hWnd,
                                  unsigned int wMsgFilterMin, unsigned int wMsgFilterMax, unsigned int wRemoveMsg);
extern int __stdcall RegisterHotKey(struct HWND__ *hWnd, int id,
                                    unsigned int fsModifiers, unsigned int vk);
extern int __stdcall UnregisterHotKey(struct HWND__ *hWnd, int id);
extern int __stdcall ExitWindowsEx(unsigned int uFlags, unsigned long dwReserved);
extern int __stdcall SwapMouseButton(int fSwap);
extern unsigned long __stdcall GetMessagePos(void);
extern long __stdcall GetMessageTime(void);
extern long __stdcall GetMessageExtraInfo(void);
extern long __stdcall SetMessageExtraInfo(long lParam);
extern long __stdcall SendMessageA(struct HWND__ *hWnd, unsigned int Msg,
                                   unsigned int wParam, long lParam);
extern long __stdcall SendMessageW(struct HWND__ *hWnd, unsigned int Msg,
                                   unsigned int wParam, long lParam);
extern long __stdcall SendMessageTimeoutA(struct HWND__ *hWnd,
                                          unsigned int Msg, unsigned int wParam, long lParam, unsigned int fuFlags,
                                          unsigned int uTimeout, unsigned long *lpdwResult);
extern long __stdcall SendMessageTimeoutW(struct HWND__ *hWnd,
                                          unsigned int Msg, unsigned int wParam, long lParam, unsigned int fuFlags,
                                          unsigned int uTimeout, unsigned long *lpdwResult);
extern int __stdcall SendNotifyMessageA(struct HWND__ *hWnd, unsigned int Msg,
                                        unsigned int wParam, long lParam);
extern int __stdcall SendNotifyMessageW(struct HWND__ *hWnd, unsigned int Msg,
                                        unsigned int wParam, long lParam);
extern int __stdcall SendMessageCallbackA(struct HWND__ *hWnd,
                                          unsigned int Msg, unsigned int wParam, long lParam, void (__stdcall *lpResultCallBack)(struct HWND__ *,
                                          unsigned int, unsigned long, long), unsigned long dwData);
extern int __stdcall SendMessageCallbackW(struct HWND__ *hWnd,
                                          unsigned int Msg, unsigned int wParam, long lParam, void (__stdcall *lpResultCallBack)(struct HWND__ *,
                                          unsigned int, unsigned long, long), unsigned long dwData);
extern long __stdcall BroadcastSystemMessage(unsigned long, unsigned long *,
                                             unsigned int, unsigned int, long);
extern int __stdcall PostMessageA(struct HWND__ *hWnd, unsigned int Msg,
                                  unsigned int wParam, long lParam);
extern int __stdcall PostMessageW(struct HWND__ *hWnd, unsigned int Msg,
                                  unsigned int wParam, long lParam);
extern int __stdcall PostThreadMessageA(unsigned long idThread,
                                        unsigned int Msg, unsigned int wParam, long lParam);
extern int __stdcall PostThreadMessageW(unsigned long idThread,
                                        unsigned int Msg, unsigned int wParam, long lParam);
extern int __stdcall AttachThreadInput(unsigned long idAttach,
                                       unsigned long idAttachTo, int fAttach);
extern int __stdcall ReplyMessage(long lResult);
extern int __stdcall WaitMessage(void);
extern unsigned long __stdcall WaitForInputIdle(void *hProcess,
                                                unsigned long dwMilliseconds);
extern long __stdcall DefWindowProcA(struct HWND__ *hWnd, unsigned int Msg,
                                     unsigned int wParam, long lParam);
extern long __stdcall DefWindowProcW(struct HWND__ *hWnd, unsigned int Msg,
                                     unsigned int wParam, long lParam);
extern void __stdcall PostQuitMessage(int nExitCode);
extern long __stdcall CallWindowProcA(long (__stdcall *lpPrevWndFunc)(struct HWND__ *,
                                      unsigned int, unsigned int, long), struct HWND__ *hWnd, unsigned int Msg,
                                      unsigned int wParam, long lParam);
extern long __stdcall CallWindowProcW(long (__stdcall *lpPrevWndFunc)(struct HWND__ *,
                                      unsigned int, unsigned int, long), struct HWND__ *hWnd, unsigned int Msg,
                                      unsigned int wParam, long lParam);
extern int __stdcall InSendMessage(void);
extern unsigned int __stdcall GetDoubleClickTime(void);
extern int __stdcall SetDoubleClickTime(unsigned int);
extern unsigned short __stdcall RegisterClassA(const struct tagWNDCLASSA *lpWndClass);
extern unsigned short __stdcall RegisterClassW(const struct tagWNDCLASSW *lpWndClass);
extern int __stdcall UnregisterClassA(const char *lpClassName,
                                      struct HINSTANCE__ *hInstance);
extern int __stdcall UnregisterClassW(const char *lpClassName,
                                      struct HINSTANCE__ *hInstance);
extern int __stdcall GetClassInfoA(struct HINSTANCE__ *hInstance,
                                   const char *lpClassName, struct tagWNDCLASSA *lpWndClass);
extern int __stdcall GetClassInfoW(struct HINSTANCE__ *hInstance,
                                   const char *lpClassName, struct tagWNDCLASSW *lpWndClass);
extern unsigned short __stdcall RegisterClassExA(const struct tagWNDCLASSEXA *);
extern unsigned short __stdcall RegisterClassExW(const struct tagWNDCLASSEXW *);
extern int __stdcall GetClassInfoExA(struct HINSTANCE__ *, const char *,
                                     struct tagWNDCLASSEXA *);
extern int __stdcall GetClassInfoExW(struct HINSTANCE__ *, const char *,
                                     struct tagWNDCLASSEXW *);
extern struct HWND__ *__stdcall CreateWindowExA(unsigned long dwExStyle,
                                                const char *lpClassName, const char *lpWindowName, unsigned long dwStyle,
                                                int X, int Y, int nWidth, int nHeight, struct HWND__ *hWndParent,
                                                struct HMENU__ *hMenu, struct HINSTANCE__ *hInstance, void *lpParam);
extern struct HWND__ *__stdcall CreateWindowExW(unsigned long dwExStyle,
                                                const char *lpClassName, const char *lpWindowName, unsigned long dwStyle,
                                                int X, int Y, int nWidth, int nHeight, struct HWND__ *hWndParent,
                                                struct HMENU__ *hMenu, struct HINSTANCE__ *hInstance, void *lpParam);
extern int __stdcall IsWindow(struct HWND__ *hWnd);
extern int __stdcall IsMenu(struct HMENU__ *hMenu);
extern int __stdcall IsChild(struct HWND__ *hWndParent, struct HWND__ *hWnd);
extern int __stdcall DestroyWindow(struct HWND__ *hWnd);
extern int __stdcall ShowWindow(struct HWND__ *hWnd, int nCmdShow);
extern int __stdcall ShowWindowAsync(struct HWND__ *hWnd, int nCmdShow);
extern int __stdcall FlashWindow(struct HWND__ *hWnd, int bInvert);
extern int __stdcall ShowOwnedPopups(struct HWND__ *hWnd, int fShow);
extern int __stdcall OpenIcon(struct HWND__ *hWnd);
extern int __stdcall CloseWindow(struct HWND__ *hWnd);
extern int __stdcall MoveWindow(struct HWND__ *hWnd, int X, int Y,
                                int nWidth, int nHeight, int bRepaint);
extern int __stdcall SetWindowPos(struct HWND__ *hWnd, struct HWND__ *hWndInsertAfter,
                                  int X, int Y, int cx, int cy, unsigned int uFlags);
extern int __stdcall GetWindowPlacement(struct HWND__ *hWnd, struct tagWINDOWPLACEMENT *lpwndpl);
extern int __stdcall SetWindowPlacement(struct HWND__ *hWnd, const struct tagWINDOWPLACEMENT *lpwndpl);
extern void *__stdcall BeginDeferWindowPos(int nNumWindows);
extern void *__stdcall DeferWindowPos(void *hWinPosInfo, struct HWND__ *hWnd,
                                      struct HWND__ *hWndInsertAfter, int x, int y, int cx, int cy, unsigned int uFlags);
extern int __stdcall EndDeferWindowPos(void *hWinPosInfo);
extern int __stdcall IsWindowVisible(struct HWND__ *hWnd);
extern int __stdcall IsIconic(struct HWND__ *hWnd);
extern int __stdcall AnyPopup(void);
extern int __stdcall BringWindowToTop(struct HWND__ *hWnd);
extern int __stdcall IsZoomed(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall CreateDialogParamA(struct HINSTANCE__ *hInstance,
                                                   const char *lpTemplateName, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                                   unsigned int, unsigned int, long), long dwInitParam);
extern struct HWND__ *__stdcall CreateDialogParamW(struct HINSTANCE__ *hInstance,
                                                   const char *lpTemplateName, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                                   unsigned int, unsigned int, long), long dwInitParam);
extern struct HWND__ *__stdcall CreateDialogIndirectParamA(struct HINSTANCE__ *hInstance,
                                                           const struct { unsigned long style;
                                                           unsigned long dwExtendedStyle;
                                                           unsigned short cdit;
                                                           short x;
                                                           short y;
                                                           short cx;
                                                           short cy;
                                                           } *lpTemplate, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                                           unsigned int, unsigned int, long), long dwInitParam);
extern struct HWND__ *__stdcall CreateDialogIndirectParamW(struct HINSTANCE__ *hInstance,
                                                           const struct { unsigned long style;
                                                           unsigned long dwExtendedStyle;
                                                           unsigned short cdit;
                                                           short x;
                                                           short y;
                                                           short cx;
                                                           short cy;
                                                           } *lpTemplate, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                                           unsigned int, unsigned int, long), long dwInitParam);
extern int __stdcall DialogBoxParamA(struct HINSTANCE__ *hInstance,
                                     const char *lpTemplateName, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                     unsigned int, unsigned int, long), long dwInitParam);
extern int __stdcall DialogBoxParamW(struct HINSTANCE__ *hInstance,
                                     const char *lpTemplateName, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                     unsigned int, unsigned int, long), long dwInitParam);
extern int __stdcall DialogBoxIndirectParamA(struct HINSTANCE__ *hInstance,
                                             const struct { unsigned long style;
                                             unsigned long dwExtendedStyle;
                                             unsigned short cdit;
                                             short x;
                                             short y;
                                             short cx;
                                             short cy;
                                             } *hDialogTemplate, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                             unsigned int, unsigned int, long), long dwInitParam);
extern int __stdcall DialogBoxIndirectParamW(struct HINSTANCE__ *hInstance,
                                             const struct { unsigned long style;
                                             unsigned long dwExtendedStyle;
                                             unsigned short cdit;
                                             short x;
                                             short y;
                                             short cx;
                                             short cy;
                                             } *hDialogTemplate, struct HWND__ *hWndParent, int (__stdcall *lpDialogFunc)(struct HWND__ *,
                                             unsigned int, unsigned int, long), long dwInitParam);
extern int __stdcall EndDialog(struct HWND__ *hDlg, int nResult);
extern struct HWND__ *__stdcall GetDlgItem(struct HWND__ *hDlg,
                                           int nIDDlgItem);
extern int __stdcall SetDlgItemInt(struct HWND__ *hDlg, int nIDDlgItem,
                                   unsigned int uValue, int bSigned);
extern unsigned int __stdcall GetDlgItemInt(struct HWND__ *hDlg,
                                            int nIDDlgItem, int *lpTranslated, int bSigned);
extern int __stdcall SetDlgItemTextA(struct HWND__ *hDlg, int nIDDlgItem,
                                     const char *lpString);
extern int __stdcall SetDlgItemTextW(struct HWND__ *hDlg, int nIDDlgItem,
                                     const char *lpString);
extern unsigned int __stdcall GetDlgItemTextA(struct HWND__ *hDlg,
                                              int nIDDlgItem, char *lpString, int nMaxCount);
extern unsigned int __stdcall GetDlgItemTextW(struct HWND__ *hDlg,
                                              int nIDDlgItem, char *lpString, int nMaxCount);
extern int __stdcall CheckDlgButton(struct HWND__ *hDlg, int nIDButton,
                                    unsigned int uCheck);
extern int __stdcall CheckRadioButton(struct HWND__ *hDlg, int nIDFirstButton,
                                      int nIDLastButton, int nIDCheckButton);
extern unsigned int __stdcall IsDlgButtonChecked(struct HWND__ *hDlg,
                                                 int nIDButton);
extern long __stdcall SendDlgItemMessageA(struct HWND__ *hDlg,
                                          int nIDDlgItem, unsigned int Msg, unsigned int wParam, long lParam);
extern long __stdcall SendDlgItemMessageW(struct HWND__ *hDlg,
                                          int nIDDlgItem, unsigned int Msg, unsigned int wParam, long lParam);
extern struct HWND__ *__stdcall GetNextDlgGroupItem(struct HWND__ *hDlg,
                                                    struct HWND__ *hCtl, int bPrevious);
extern struct HWND__ *__stdcall GetNextDlgTabItem(struct HWND__ *hDlg,
                                                  struct HWND__ *hCtl, int bPrevious);
extern int __stdcall GetDlgCtrlID(struct HWND__ *hWnd);
extern long __stdcall GetDialogBaseUnits(void);
extern long __stdcall DefDlgProcA(struct HWND__ *hDlg, unsigned int Msg,
                                  unsigned int wParam, long lParam);
extern long __stdcall DefDlgProcW(struct HWND__ *hDlg, unsigned int Msg,
                                  unsigned int wParam, long lParam);
extern int __stdcall CallMsgFilterA(struct tagMSG *lpMsg, int nCode);
extern int __stdcall CallMsgFilterW(struct tagMSG *lpMsg, int nCode);
extern int __stdcall OpenClipboard(struct HWND__ *hWndNewOwner);
extern int __stdcall CloseClipboard(void);
extern struct HWND__ *__stdcall GetClipboardOwner(void);
extern struct HWND__ *__stdcall SetClipboardViewer(struct HWND__ *hWndNewViewer);
extern struct HWND__ *__stdcall GetClipboardViewer(void);
extern int __stdcall ChangeClipboardChain(struct HWND__ *hWndRemove,
                                          struct HWND__ *hWndNewNext);
extern void *__stdcall SetClipboardData(unsigned int uFormat, void *hMem);
extern void *__stdcall GetClipboardData(unsigned int uFormat);
extern unsigned int __stdcall RegisterClipboardFormatA(const char *lpszFormat);
extern unsigned int __stdcall RegisterClipboardFormatW(const char *lpszFormat);
extern int __stdcall CountClipboardFormats(void);
extern unsigned int __stdcall EnumClipboardFormats(unsigned int format);
extern int __stdcall GetClipboardFormatNameA(unsigned int format,
                                             char *lpszFormatName, int cchMaxCount);
extern int __stdcall GetClipboardFormatNameW(unsigned int format,
                                             char *lpszFormatName, int cchMaxCount);
extern int __stdcall EmptyClipboard(void);
extern int __stdcall IsClipboardFormatAvailable(unsigned int format);
extern int __stdcall GetPriorityClipboardFormat(unsigned int *paFormatPriorityList,
                                                int cFormats);
extern struct HWND__ *__stdcall GetOpenClipboardWindow(void);
extern int __stdcall CharToOemA(const char *lpszSrc, char *lpszDst);
extern int __stdcall CharToOemW(const char *lpszSrc, char *lpszDst);
extern int __stdcall OemToCharA(const char *lpszSrc, char *lpszDst);
extern int __stdcall OemToCharW(const char *lpszSrc, char *lpszDst);
extern int __stdcall CharToOemBuffA(const char *lpszSrc, char *lpszDst,
                                    unsigned long cchDstLength);
extern int __stdcall CharToOemBuffW(const char *lpszSrc, char *lpszDst,
                                    unsigned long cchDstLength);
extern int __stdcall OemToCharBuffA(const char *lpszSrc, char *lpszDst,
                                    unsigned long cchDstLength);
extern int __stdcall OemToCharBuffW(const char *lpszSrc, char *lpszDst,
                                    unsigned long cchDstLength);
extern char *__stdcall CharUpperA(char *lpsz);
extern char *__stdcall CharUpperW(char *lpsz);
extern unsigned long __stdcall CharUpperBuffA(char *lpsz, unsigned long cchLength);
extern unsigned long __stdcall CharUpperBuffW(char *lpsz, unsigned long cchLength);
extern char *__stdcall CharLowerA(char *lpsz);
extern char *__stdcall CharLowerW(char *lpsz);
extern unsigned long __stdcall CharLowerBuffA(char *lpsz, unsigned long cchLength);
extern unsigned long __stdcall CharLowerBuffW(char *lpsz, unsigned long cchLength);
extern char *__stdcall CharNextA(const char *lpsz);
extern char *__stdcall CharNextW(const char *lpsz);
extern char *__stdcall CharPrevA(const char *lpszStart, const char *lpszCurrent);
extern char *__stdcall CharPrevW(const char *lpszStart, const char *lpszCurrent);
extern char *__stdcall CharNextExA(unsigned short CodePage, const char *lpCurrentChar,
                                   unsigned long dwFlags);
extern int __stdcall IsCharAlphaA(char ch);
extern int __stdcall IsCharAlphaW(char ch);
extern int __stdcall IsCharAlphaNumericA(char ch);
extern int __stdcall IsCharAlphaNumericW(char ch);
extern int __stdcall IsCharUpperA(char ch);
extern int __stdcall IsCharUpperW(char ch);
extern int __stdcall IsCharLowerA(char ch);
extern int __stdcall IsCharLowerW(char ch);
extern struct HWND__ *__stdcall SetFocus(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall GetActiveWindow(void);
extern struct HWND__ *__stdcall GetFocus(void);
extern unsigned int __stdcall GetKBCodePage(void);
extern short __stdcall GetKeyState(int nVirtKey);
extern short __stdcall GetAsyncKeyState(int vKey);
extern int __stdcall GetKeyboardState(unsigned char *lpKeyState);
extern int __stdcall SetKeyboardState(unsigned char *lpKeyState);
extern int __stdcall GetKeyNameTextA(long lParam, char *lpString,
                                     int nSize);
extern int __stdcall GetKeyNameTextW(long lParam, char *lpString,
                                     int nSize);
extern int __stdcall GetKeyboardType(int nTypeFlag);
extern int __stdcall ToAscii(unsigned int uVirtKey, unsigned int uScanCode,
                             unsigned char *lpKeyState, unsigned short *lpChar, unsigned int uFlags);
extern int __stdcall ToAsciiEx(unsigned int uVirtKey, unsigned int uScanCode,
                               unsigned char *lpKeyState, unsigned short *lpChar, unsigned int uFlags,
                               struct HKL__ *dwhkl);
extern int __stdcall ToUnicode(unsigned int wVirtKey, unsigned int wScanCode,
                               unsigned char *lpKeyState, char *pwszBuff, int cchBuff, unsigned int wFlags);
extern unsigned long __stdcall OemKeyScan(unsigned short wOemChar);
extern short __stdcall VkKeyScanA(char ch);
extern short __stdcall VkKeyScanW(char ch);
extern short __stdcall VkKeyScanExA(char ch, struct HKL__ *dwhkl);
extern short __stdcall VkKeyScanExW(char ch, struct HKL__ *dwhkl);
extern void __stdcall keybd_event(unsigned char bVk, unsigned char bScan,
                                  unsigned long dwFlags, unsigned long dwExtraInfo);
extern void __stdcall mouse_event(unsigned long dwFlags, unsigned long dx,
                                  unsigned long dy, unsigned long cButtons, unsigned long dwExtraInfo);
extern unsigned int __stdcall MapVirtualKeyA(unsigned int uCode,
                                             unsigned int uMapType);
extern unsigned int __stdcall MapVirtualKeyW(unsigned int uCode,
                                             unsigned int uMapType);
extern unsigned int __stdcall MapVirtualKeyExA(unsigned int uCode,
                                               unsigned int uMapType, struct HKL__ *dwhkl);
extern int __stdcall GetInputState(void);
extern unsigned long __stdcall GetQueueStatus(unsigned int flags);
extern struct HWND__ *__stdcall GetCapture(void);
extern struct HWND__ *__stdcall SetCapture(struct HWND__ *hWnd);
extern int __stdcall ReleaseCapture(void);
extern unsigned long __stdcall MsgWaitForMultipleObjects(unsigned long nCount,
                                                         void **pHandles, int fWaitAll, unsigned long dwMilliseconds, unsigned long dwWakeMask);
extern unsigned int __stdcall SetTimer(struct HWND__ *hWnd, unsigned int nIDEvent,
                                       unsigned int uElapse, void (__stdcall *lpTimerFunc)(struct HWND__ *,
                                       unsigned int, unsigned int, unsigned long));
extern int __stdcall KillTimer(struct HWND__ *hWnd, unsigned int uIDEvent);
extern int __stdcall IsWindowUnicode(struct HWND__ *hWnd);
extern int __stdcall EnableWindow(struct HWND__ *hWnd, int bEnable);
extern int __stdcall IsWindowEnabled(struct HWND__ *hWnd);
extern struct HACCEL__ *__stdcall LoadAcceleratorsA(struct HINSTANCE__ *hInstance,
                                                    const char *lpTableName);
extern struct HACCEL__ *__stdcall LoadAcceleratorsW(struct HINSTANCE__ *hInstance,
                                                    const char *lpTableName);
extern struct HACCEL__ *__stdcall CreateAcceleratorTableA(struct tagACCEL *,
                                                          int);
extern struct HACCEL__ *__stdcall CreateAcceleratorTableW(struct tagACCEL *,
                                                          int);
extern int __stdcall DestroyAcceleratorTable(struct HACCEL__ *hAccel);
extern int __stdcall CopyAcceleratorTableA(struct HACCEL__ *hAccelSrc,
                                           struct tagACCEL *lpAccelDst, int cAccelEntries);
extern int __stdcall CopyAcceleratorTableW(struct HACCEL__ *hAccelSrc,
                                           struct tagACCEL *lpAccelDst, int cAccelEntries);
extern int __stdcall TranslateAcceleratorA(struct HWND__ *hWnd,
                                           struct HACCEL__ *hAccTable, struct tagMSG *lpMsg);
extern int __stdcall TranslateAcceleratorW(struct HWND__ *hWnd,
                                           struct HACCEL__ *hAccTable, struct tagMSG *lpMsg);
extern int __stdcall GetSystemMetrics(int nIndex);
extern struct HMENU__ *__stdcall LoadMenuA(struct HINSTANCE__ *hInstance,
                                           const char *lpMenuName);
extern struct HMENU__ *__stdcall LoadMenuW(struct HINSTANCE__ *hInstance,
                                           const char *lpMenuName);
extern struct HMENU__ *__stdcall LoadMenuIndirectA(const void *lpMenuTemplate);
extern struct HMENU__ *__stdcall LoadMenuIndirectW(const void *lpMenuTemplate);
extern struct HMENU__ *__stdcall GetMenu(struct HWND__ *hWnd);
extern int __stdcall SetMenu(struct HWND__ *hWnd, struct HMENU__ *hMenu);
extern int __stdcall ChangeMenuA(struct HMENU__ *hMenu, unsigned int cmd,
                                 const char *lpszNewItem, unsigned int cmdInsert, unsigned int flags);
extern int __stdcall ChangeMenuW(struct HMENU__ *hMenu, unsigned int cmd,
                                 const char *lpszNewItem, unsigned int cmdInsert, unsigned int flags);
extern int __stdcall HiliteMenuItem(struct HWND__ *hWnd, struct HMENU__ *hMenu,
                                    unsigned int uIDHiliteItem, unsigned int uHilite);
extern int __stdcall GetMenuStringA(struct HMENU__ *hMenu, unsigned int uIDItem,
                                    char *lpString, int nMaxCount, unsigned int uFlag);
extern int __stdcall GetMenuStringW(struct HMENU__ *hMenu, unsigned int uIDItem,
                                    char *lpString, int nMaxCount, unsigned int uFlag);
extern unsigned int __stdcall GetMenuState(struct HMENU__ *hMenu,
                                           unsigned int uId, unsigned int uFlags);
extern int __stdcall DrawMenuBar(struct HWND__ *hWnd);
extern struct HMENU__ *__stdcall GetSystemMenu(struct HWND__ *hWnd,
                                               int bRevert);
extern struct HMENU__ *__stdcall CreateMenu(void);
extern struct HMENU__ *__stdcall CreatePopupMenu(void);
extern int __stdcall DestroyMenu(struct HMENU__ *hMenu);
extern unsigned long __stdcall CheckMenuItem(struct HMENU__ *hMenu,
                                             unsigned int uIDCheckItem, unsigned int uCheck);
extern int __stdcall EnableMenuItem(struct HMENU__ *hMenu, unsigned int uIDEnableItem,
                                    unsigned int uEnable);
extern struct HMENU__ *__stdcall GetSubMenu(struct HMENU__ *hMenu,
                                            int nPos);
extern unsigned int __stdcall GetMenuItemID(struct HMENU__ *hMenu,
                                            int nPos);
extern int __stdcall GetMenuItemCount(struct HMENU__ *hMenu);
extern int __stdcall InsertMenuA(struct HMENU__ *hMenu, unsigned int uPosition,
                                 unsigned int uFlags, unsigned int uIDNewItem, const char *lpNewItem);
extern int __stdcall InsertMenuW(struct HMENU__ *hMenu, unsigned int uPosition,
                                 unsigned int uFlags, unsigned int uIDNewItem, const char *lpNewItem);
extern int __stdcall AppendMenuA(struct HMENU__ *hMenu, unsigned int uFlags,
                                 unsigned int uIDNewItem, const char *lpNewItem);
extern int __stdcall AppendMenuW(struct HMENU__ *hMenu, unsigned int uFlags,
                                 unsigned int uIDNewItem, const char *lpNewItem);
extern int __stdcall ModifyMenuA(struct HMENU__ *hMnu, unsigned int uPosition,
                                 unsigned int uFlags, unsigned int uIDNewItem, const char *lpNewItem);
extern int __stdcall ModifyMenuW(struct HMENU__ *hMnu, unsigned int uPosition,
                                 unsigned int uFlags, unsigned int uIDNewItem, const char *lpNewItem);
extern int __stdcall RemoveMenu(struct HMENU__ *hMenu, unsigned int uPosition,
                                unsigned int uFlags);
extern int __stdcall DeleteMenu(struct HMENU__ *hMenu, unsigned int uPosition,
                                unsigned int uFlags);
extern int __stdcall SetMenuItemBitmaps(struct HMENU__ *hMenu,
                                        unsigned int uPosition, unsigned int uFlags, struct HBITMAP__ *hBitmapUnchecked,
                                        struct HBITMAP__ *hBitmapChecked);
extern long __stdcall GetMenuCheckMarkDimensions(void);
extern int __stdcall TrackPopupMenu(struct HMENU__ *hMenu, unsigned int uFlags,
                                    int x, int y, int nReserved, struct HWND__ *hWnd, const struct tagRECT *prcRect);
extern int __stdcall TrackPopupMenuEx(struct HMENU__ *, unsigned int,
                                      int, int, struct HWND__ *, struct tagTPMPARAMS *);
extern int __stdcall InsertMenuItemA(struct HMENU__ *, unsigned int,
                                     int, const struct tagMENUITEMINFOA *);
extern int __stdcall InsertMenuItemW(struct HMENU__ *, unsigned int,
                                     int, const struct tagMENUITEMINFOW *);
extern int __stdcall GetMenuItemInfoA(struct HMENU__ *, unsigned int,
                                      int, struct tagMENUITEMINFOA *);
extern int __stdcall GetMenuItemInfoW(struct HMENU__ *, unsigned int,
                                      int, struct tagMENUITEMINFOW *);
extern int __stdcall SetMenuItemInfoA(struct HMENU__ *, unsigned int,
                                      int, const struct tagMENUITEMINFOA *);
extern int __stdcall SetMenuItemInfoW(struct HMENU__ *, unsigned int,
                                      int, const struct tagMENUITEMINFOW *);
extern unsigned int __stdcall GetMenuDefaultItem(struct HMENU__ *hMenu,
                                                 unsigned int fByPos, unsigned int gmdiFlags);
extern int __stdcall SetMenuDefaultItem(struct HMENU__ *hMenu,
                                        unsigned int uItem, unsigned int fByPos);
extern int __stdcall GetMenuItemRect(struct HWND__ *hWnd, struct HMENU__ *hMenu,
                                     unsigned int uItem, struct tagRECT *lprcItem);
extern int __stdcall MenuItemFromPoint(struct HWND__ *hWnd, struct HMENU__ *hMenu,
                                       struct tagPOINT ptScreen);
extern unsigned long __stdcall DragObject(struct HWND__ *, struct HWND__ *,
                                          unsigned int, unsigned long, struct HICON__ *);
extern int __stdcall DragDetect(struct HWND__ *, struct tagPOINT);
extern int __stdcall DrawIcon(struct HDC__ *hDC, int X, int Y,
                              struct HICON__ *hIcon);
extern int __stdcall DrawTextA(struct HDC__ *hDC, const char *lpString,
                               int nCount, struct tagRECT *lpRect, unsigned int uFormat);
extern int __stdcall DrawTextW(struct HDC__ *hDC, const char *lpString,
                               int nCount, struct tagRECT *lpRect, unsigned int uFormat);
extern int __stdcall DrawTextExA(struct HDC__ *, char *, int, struct tagRECT *,
                                 unsigned int, struct tagDRAWTEXTPARAMS *);
extern int __stdcall DrawTextExW(struct HDC__ *, char *, int, struct tagRECT *,
                                 unsigned int, struct tagDRAWTEXTPARAMS *);
extern int __stdcall GrayStringA(struct HDC__ *hDC, struct HBRUSH__ *hBrush,
                                 int (__stdcall *lpOutputFunc)(struct HDC__ *, long, int), long lpData,
                                 int nCount, int X, int Y, int nWidth, int nHeight);
extern int __stdcall GrayStringW(struct HDC__ *hDC, struct HBRUSH__ *hBrush,
                                 int (__stdcall *lpOutputFunc)(struct HDC__ *, long, int), long lpData,
                                 int nCount, int X, int Y, int nWidth, int nHeight);
extern int __stdcall DrawStateA(struct HDC__ *, struct HBRUSH__ *,
                                int (__stdcall *)(struct HDC__ *hdc, long lData, unsigned int wData,
                                int cx, int cy), long, unsigned int, int, int, int, int, unsigned int);
extern int __stdcall DrawStateW(struct HDC__ *, struct HBRUSH__ *,
                                int (__stdcall *)(struct HDC__ *hdc, long lData, unsigned int wData,
                                int cx, int cy), long, unsigned int, int, int, int, int, unsigned int);
extern long __stdcall TabbedTextOutA(struct HDC__ *hDC, int X,
                                     int Y, const char *lpString, int nCount, int nTabPositions, int *lpnTabStopPositions,
                                     int nTabOrigin);
extern long __stdcall TabbedTextOutW(struct HDC__ *hDC, int X,
                                     int Y, const char *lpString, int nCount, int nTabPositions, int *lpnTabStopPositions,
                                     int nTabOrigin);
extern unsigned long __stdcall GetTabbedTextExtentA(struct HDC__ *hDC,
                                                    const char *lpString, int nCount, int nTabPositions, int *lpnTabStopPositions);
extern unsigned long __stdcall GetTabbedTextExtentW(struct HDC__ *hDC,
                                                    const char *lpString, int nCount, int nTabPositions, int *lpnTabStopPositions);
extern int __stdcall UpdateWindow(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall SetActiveWindow(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall GetForegroundWindow(void);
extern int __stdcall PaintDesktop(struct HDC__ *hdc);
extern int __stdcall SetForegroundWindow(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall WindowFromDC(struct HDC__ *hDC);
extern struct HDC__ *__stdcall GetDC(struct HWND__ *hWnd);
extern struct HDC__ *__stdcall GetDCEx(struct HWND__ *hWnd, struct HRGN__ *hrgnClip,
                                       unsigned long flags);
extern struct HDC__ *__stdcall GetWindowDC(struct HWND__ *hWnd);
extern int __stdcall ReleaseDC(struct HWND__ *hWnd, struct HDC__ *hDC);
extern struct HDC__ *__stdcall BeginPaint(struct HWND__ *hWnd,
                                          struct tagPAINTSTRUCT *lpPaint);
extern int __stdcall EndPaint(struct HWND__ *hWnd, const struct tagPAINTSTRUCT *lpPaint);
extern int __stdcall GetUpdateRect(struct HWND__ *hWnd, struct tagRECT *lpRect,
                                   int bErase);
extern int __stdcall GetUpdateRgn(struct HWND__ *hWnd, struct HRGN__ *hRgn,
                                  int bErase);
extern int __stdcall ExcludeUpdateRgn(struct HDC__ *hDC, struct HWND__ *hWnd);
extern int __stdcall InvalidateRect(struct HWND__ *hWnd, const struct tagRECT *lpRect,
                                    int bErase);
extern int __stdcall ValidateRect(struct HWND__ *hWnd, const struct tagRECT *lpRect);
extern int __stdcall InvalidateRgn(struct HWND__ *hWnd, struct HRGN__ *hRgn,
                                   int bErase);
extern int __stdcall ValidateRgn(struct HWND__ *hWnd, struct HRGN__ *hRgn);
extern int __stdcall RedrawWindow(struct HWND__ *hWnd, const struct tagRECT *lprcUpdate,
                                  struct HRGN__ *hrgnUpdate, unsigned int flags);
extern int __stdcall LockWindowUpdate(struct HWND__ *hWndLock);
extern int __stdcall ScrollWindow(struct HWND__ *hWnd, int XAmount,
                                  int YAmount, const struct tagRECT *lpRect, const struct tagRECT *lpClipRect);
extern int __stdcall ScrollDC(struct HDC__ *hDC, int dx, int dy,
                              const struct tagRECT *lprcScroll, const struct tagRECT *lprcClip,
                              struct HRGN__ *hrgnUpdate, struct tagRECT *lprcUpdate);
extern int __stdcall ScrollWindowEx(struct HWND__ *hWnd, int dx,
                                    int dy, const struct tagRECT *prcScroll, const struct tagRECT *prcClip,
                                    struct HRGN__ *hrgnUpdate, struct tagRECT *prcUpdate, unsigned int flags);
extern int __stdcall SetScrollPos(struct HWND__ *hWnd, int nBar,
                                  int nPos, int bRedraw);
extern int __stdcall GetScrollPos(struct HWND__ *hWnd, int nBar);
extern int __stdcall SetScrollRange(struct HWND__ *hWnd, int nBar,
                                    int nMinPos, int nMaxPos, int bRedraw);
extern int __stdcall GetScrollRange(struct HWND__ *hWnd, int nBar,
                                    int *lpMinPos, int *lpMaxPos);
extern int __stdcall ShowScrollBar(struct HWND__ *hWnd, int wBar,
                                   int bShow);
extern int __stdcall EnableScrollBar(struct HWND__ *hWnd, unsigned int wSBflags,
                                     unsigned int wArrows);
extern int __stdcall SetPropA(struct HWND__ *hWnd, const char *lpString,
                              void *hData);
extern int __stdcall SetPropW(struct HWND__ *hWnd, const char *lpString,
                              void *hData);
extern void *__stdcall GetPropA(struct HWND__ *hWnd, const char *lpString);
extern void *__stdcall GetPropW(struct HWND__ *hWnd, const char *lpString);
extern void *__stdcall RemovePropA(struct HWND__ *hWnd, const char *lpString);
extern void *__stdcall RemovePropW(struct HWND__ *hWnd, const char *lpString);
extern int __stdcall EnumPropsExA(struct HWND__ *hWnd, int (__stdcall *lpEnumFunc)(struct HWND__ *,
                                  char *, void *, unsigned long), long lParam);
extern int __stdcall EnumPropsExW(struct HWND__ *hWnd, int (__stdcall *lpEnumFunc)(struct HWND__ *,
                                  char *, void *, unsigned long), long lParam);
extern int __stdcall EnumPropsA(struct HWND__ *hWnd, int (__stdcall *lpEnumFunc)(struct HWND__ *,
                                const char *, void *));
extern int __stdcall EnumPropsW(struct HWND__ *hWnd, int (__stdcall *lpEnumFunc)(struct HWND__ *,
                                const char *, void *));
extern int __stdcall SetWindowTextA(struct HWND__ *hWnd, const char *lpString);
extern int __stdcall SetWindowTextW(struct HWND__ *hWnd, const char *lpString);
extern int __stdcall GetWindowTextA(struct HWND__ *hWnd, char *lpString,
                                    int nMaxCount);
extern int __stdcall GetWindowTextW(struct HWND__ *hWnd, char *lpString,
                                    int nMaxCount);
extern int __stdcall GetWindowTextLengthA(struct HWND__ *hWnd);
extern int __stdcall GetWindowTextLengthW(struct HWND__ *hWnd);
extern int __stdcall GetClientRect(struct HWND__ *hWnd, struct tagRECT *lpRect);
extern int __stdcall GetWindowRect(struct HWND__ *hWnd, struct tagRECT *lpRect);
extern int __stdcall AdjustWindowRect(struct tagRECT *lpRect, unsigned long dwStyle,
                                      int bMenu);
extern int __stdcall AdjustWindowRectEx(struct tagRECT *lpRect,
                                        unsigned long dwStyle, int bMenu, unsigned long dwExStyle);
extern int __stdcall SetWindowContextHelpId(struct HWND__ *, unsigned long);
extern unsigned long __stdcall GetWindowContextHelpId(struct HWND__ *);
extern int __stdcall SetMenuContextHelpId(struct HMENU__ *, unsigned long);
extern unsigned long __stdcall GetMenuContextHelpId(struct HMENU__ *);
extern int __stdcall MessageBoxA(struct HWND__ *hWnd, const char *lpText,
                                 const char *lpCaption, unsigned int uType);
extern int __stdcall MessageBoxW(struct HWND__ *hWnd, const char *lpText,
                                 const char *lpCaption, unsigned int uType);
extern int __stdcall MessageBoxExA(struct HWND__ *hWnd, const char *lpText,
                                   const char *lpCaption, unsigned int uType, unsigned short wLanguageId);
extern int __stdcall MessageBoxExW(struct HWND__ *hWnd, const char *lpText,
                                   const char *lpCaption, unsigned int uType, unsigned short wLanguageId);
extern int __stdcall MessageBoxIndirectA(struct tagMSGBOXPARAMSA *);
extern int __stdcall MessageBoxIndirectW(struct tagMSGBOXPARAMSW *);
extern int __stdcall MessageBeep(unsigned int uType);
extern int __stdcall ShowCursor(int bShow);
extern int __stdcall SetCursorPos(int X, int Y);
extern struct HICON__ *__stdcall SetCursor(struct HICON__ *hCursor);
extern int __stdcall GetCursorPos(struct tagPOINT *lpPoint);
extern int __stdcall ClipCursor(const struct tagRECT *lpRect);
extern int __stdcall GetClipCursor(struct tagRECT *lpRect);
extern struct HICON__ *__stdcall GetCursor(void);
extern int __stdcall CreateCaret(struct HWND__ *hWnd, struct HBITMAP__ *hBitmap,
                                 int nWidth, int nHeight);
extern unsigned int __stdcall GetCaretBlinkTime(void);
extern int __stdcall SetCaretBlinkTime(unsigned int uMSeconds);
extern int __stdcall DestroyCaret(void);
extern int __stdcall HideCaret(struct HWND__ *hWnd);
extern int __stdcall ShowCaret(struct HWND__ *hWnd);
extern int __stdcall SetCaretPos(int X, int Y);
extern int __stdcall GetCaretPos(struct tagPOINT *lpPoint);
extern int __stdcall ClientToScreen(struct HWND__ *hWnd, struct tagPOINT *lpPoint);
extern int __stdcall ScreenToClient(struct HWND__ *hWnd, struct tagPOINT *lpPoint);
extern int __stdcall MapWindowPoints(struct HWND__ *hWndFrom, struct HWND__ *hWndTo,
                                     struct tagPOINT *lpPoints, unsigned int cPoints);
extern struct HWND__ *__stdcall WindowFromPoint(struct tagPOINT Point);
extern struct HWND__ *__stdcall ChildWindowFromPoint(struct HWND__ *hWndParent,
                                                     struct tagPOINT Point);
extern struct HWND__ *__stdcall ChildWindowFromPointEx(struct HWND__ *,
                                                       struct tagPOINT, unsigned int);
extern unsigned long __stdcall GetSysColor(int nIndex);
extern struct HBRUSH__ *__stdcall GetSysColorBrush(int nIndex);
extern int __stdcall SetSysColors(int cElements, const int *lpaElements,
                                  const unsigned long *lpaRgbValues);
extern int __stdcall DrawFocusRect(struct HDC__ *hDC, const struct tagRECT *lprc);
extern int __stdcall FillRect(struct HDC__ *hDC, const struct tagRECT *lprc,
                              struct HBRUSH__ *hbr);
extern int __stdcall FrameRect(struct HDC__ *hDC, const struct tagRECT *lprc,
                               struct HBRUSH__ *hbr);
extern int __stdcall InvertRect(struct HDC__ *hDC, const struct tagRECT *lprc);
extern int __stdcall SetRect(struct tagRECT *lprc, int xLeft, int yTop,
                             int xRight, int yBottom);
extern int __stdcall SetRectEmpty(struct tagRECT *lprc);
extern int __stdcall CopyRect(struct tagRECT *lprcDst, const struct tagRECT *lprcSrc);
extern int __stdcall InflateRect(struct tagRECT *lprc, int dx,
                                 int dy);
extern int __stdcall IntersectRect(struct tagRECT *lprcDst, const struct tagRECT *lprcSrc1,
                                   const struct tagRECT *lprcSrc2);
extern int __stdcall UnionRect(struct tagRECT *lprcDst, const struct tagRECT *lprcSrc1,
                               const struct tagRECT *lprcSrc2);
extern int __stdcall SubtractRect(struct tagRECT *lprcDst, const struct tagRECT *lprcSrc1,
                                  const struct tagRECT *lprcSrc2);
extern int __stdcall OffsetRect(struct tagRECT *lprc, int dx, int dy);
extern int __stdcall IsRectEmpty(const struct tagRECT *lprc);
extern int __stdcall EqualRect(const struct tagRECT *lprc1, const struct tagRECT *lprc2);
extern int __stdcall PtInRect(const struct tagRECT *lprc, struct tagPOINT pt);
extern unsigned short __stdcall GetWindowWord(struct HWND__ *hWnd,
                                              int nIndex);
extern unsigned short __stdcall SetWindowWord(struct HWND__ *hWnd,
                                              int nIndex, unsigned short wNewWord);
extern long __stdcall GetWindowLongA(struct HWND__ *hWnd, int nIndex);
extern long __stdcall GetWindowLongW(struct HWND__ *hWnd, int nIndex);
extern long __stdcall SetWindowLongA(struct HWND__ *hWnd, int nIndex,
                                     long dwNewLong);
extern long __stdcall SetWindowLongW(struct HWND__ *hWnd, int nIndex,
                                     long dwNewLong);
extern unsigned short __stdcall GetClassWord(struct HWND__ *hWnd,
                                             int nIndex);
extern unsigned short __stdcall SetClassWord(struct HWND__ *hWnd,
                                             int nIndex, unsigned short wNewWord);
extern unsigned long __stdcall GetClassLongA(struct HWND__ *hWnd,
                                             int nIndex);
extern unsigned long __stdcall GetClassLongW(struct HWND__ *hWnd,
                                             int nIndex);
extern unsigned long __stdcall SetClassLongA(struct HWND__ *hWnd,
                                             int nIndex, long dwNewLong);
extern unsigned long __stdcall SetClassLongW(struct HWND__ *hWnd,
                                             int nIndex, long dwNewLong);
extern struct HWND__ *__stdcall GetDesktopWindow(void);
extern struct HWND__ *__stdcall GetParent(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall SetParent(struct HWND__ *hWndChild,
                                          struct HWND__ *hWndNewParent);
extern int __stdcall EnumChildWindows(struct HWND__ *hWndParent,
                                      int (__stdcall *lpEnumFunc)(struct HWND__ *, long), long lParam);
extern struct HWND__ *__stdcall FindWindowA(const char *lpClassName,
                                            const char *lpWindowName);
extern struct HWND__ *__stdcall FindWindowW(const char *lpClassName,
                                            const char *lpWindowName);
extern struct HWND__ *__stdcall FindWindowExA(struct HWND__ *,
                                              struct HWND__ *, const char *, const char *);
extern struct HWND__ *__stdcall FindWindowExW(struct HWND__ *,
                                              struct HWND__ *, const char *, const char *);
extern int __stdcall EnumWindows(int (__stdcall *lpEnumFunc)(struct HWND__ *,
                                 long), long lParam);
extern int __stdcall EnumThreadWindows(unsigned long dwThreadId,
                                       int (__stdcall *lpfn)(struct HWND__ *, long), long lParam);
extern int __stdcall GetClassNameA(struct HWND__ *hWnd, char *lpClassName,
                                   int nMaxCount);
extern int __stdcall GetClassNameW(struct HWND__ *hWnd, char *lpClassName,
                                   int nMaxCount);
extern struct HWND__ *__stdcall GetTopWindow(struct HWND__ *hWnd);
extern unsigned long __stdcall GetWindowThreadProcessId(struct HWND__ *hWnd,
                                                        unsigned long *lpdwProcessId);
extern struct HWND__ *__stdcall GetLastActivePopup(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall GetWindow(struct HWND__ *hWnd,
                                          unsigned int uCmd);
extern struct HHOOK__ *__stdcall SetWindowsHookA(int nFilterType,
                                                 long (__stdcall *pfnFilterProc)(int code, unsigned int wParam,
                                                 long lParam));
extern struct HHOOK__ *__stdcall SetWindowsHookW(int nFilterType,
                                                 long (__stdcall *pfnFilterProc)(int code, unsigned int wParam,
                                                 long lParam));
extern int __stdcall UnhookWindowsHook(int nCode, long (__stdcall *pfnFilterProc)(int code,
                                       unsigned int wParam, long lParam));
extern struct HHOOK__ *__stdcall SetWindowsHookExA(int idHook,
                                                   long (__stdcall *lpfn)(int code, unsigned int wParam, long lParam),
                                                   struct HINSTANCE__ *hmod, unsigned long dwThreadId);
extern struct HHOOK__ *__stdcall SetWindowsHookExW(int idHook,
                                                   long (__stdcall *lpfn)(int code, unsigned int wParam, long lParam),
                                                   struct HINSTANCE__ *hmod, unsigned long dwThreadId);
extern int __stdcall UnhookWindowsHookEx(struct HHOOK__ *hhk);
extern long __stdcall CallNextHookEx(struct HHOOK__ *hhk, int nCode,
                                     unsigned int wParam, long lParam);
extern int __stdcall CheckMenuRadioItem(struct HMENU__ *, unsigned int,
                                        unsigned int, unsigned int, unsigned int);
extern struct HBITMAP__ *__stdcall LoadBitmapA(struct HINSTANCE__ *hInstance,
                                               const char *lpBitmapName);
extern struct HBITMAP__ *__stdcall LoadBitmapW(struct HINSTANCE__ *hInstance,
                                               const char *lpBitmapName);
extern struct HICON__ *__stdcall LoadCursorA(struct HINSTANCE__ *hInstance,
                                             const char *lpCursorName);
extern struct HICON__ *__stdcall LoadCursorW(struct HINSTANCE__ *hInstance,
                                             const char *lpCursorName);
extern struct HICON__ *__stdcall LoadCursorFromFileA(const char *lpFileName);
extern struct HICON__ *__stdcall LoadCursorFromFileW(const char *lpFileName);
extern struct HICON__ *__stdcall CreateCursor(struct HINSTANCE__ *hInst,
                                              int xHotSpot, int yHotSpot, int nWidth, int nHeight, const void *pvANDPlane,
                                              const void *pvXORPlane);
extern int __stdcall DestroyCursor(struct HICON__ *hCursor);
extern int __stdcall SetSystemCursor(struct HICON__ *hcur, unsigned long id);
extern struct HICON__ *__stdcall LoadIconA(struct HINSTANCE__ *hInstance,
                                           const char *lpIconName);
extern struct HICON__ *__stdcall LoadIconW(struct HINSTANCE__ *hInstance,
                                           const char *lpIconName);
extern struct HICON__ *__stdcall CreateIcon(struct HINSTANCE__ *hInstance,
                                            int nWidth, int nHeight, unsigned char cPlanes, unsigned char cBitsPixel,
                                            const unsigned char *lpbANDbits, const unsigned char *lpbXORbits);
extern int __stdcall DestroyIcon(struct HICON__ *hIcon);
extern int __stdcall LookupIconIdFromDirectory(unsigned char *presbits,
                                               int fIcon);
extern int __stdcall LookupIconIdFromDirectoryEx(unsigned char *presbits,
                                                 int fIcon, int cxDesired, int cyDesired, unsigned int Flags);
extern struct HICON__ *__stdcall CreateIconFromResource(unsigned char *presbits,
                                                        unsigned long dwResSize, int fIcon, unsigned long dwVer);
extern struct HICON__ *__stdcall CreateIconFromResourceEx(unsigned char *presbits,
                                                          unsigned long dwResSize, int fIcon, unsigned long dwVer, int cxDesired,
                                                          int cyDesired, unsigned int Flags);
extern void *__stdcall LoadImageA(struct HINSTANCE__ *, const char *,
                                  unsigned int, int, int, unsigned int);
extern void *__stdcall LoadImageW(struct HINSTANCE__ *, const char *,
                                  unsigned int, int, int, unsigned int);
extern struct HICON__ *__stdcall CopyImage(void *, unsigned int,
                                           int, int, unsigned int);
extern int __stdcall DrawIconEx(struct HDC__ *hdc, int xLeft, int yTop,
                                struct HICON__ *hIcon, int cxWidth, int cyWidth, unsigned int istepIfAniCur,
                                struct HBRUSH__ *hbrFlickerFreeDraw, unsigned int diFlags);
extern struct HICON__ *__stdcall CreateIconIndirect(struct _ICONINFO *piconinfo);
extern struct HICON__ *__stdcall CopyIcon(struct HICON__ *hIcon);
extern int __stdcall GetIconInfo(struct HICON__ *hIcon, struct _ICONINFO *piconinfo);
extern int __stdcall LoadStringA(struct HINSTANCE__ *hInstance,
                                 unsigned int uID, char *lpBuffer, int nBufferMax);
extern int __stdcall LoadStringW(struct HINSTANCE__ *hInstance,
                                 unsigned int uID, char *lpBuffer, int nBufferMax);
extern int __stdcall IsDialogMessageA(struct HWND__ *hDlg, struct tagMSG *lpMsg);
extern int __stdcall IsDialogMessageW(struct HWND__ *hDlg, struct tagMSG *lpMsg);
extern int __stdcall MapDialogRect(struct HWND__ *hDlg, struct tagRECT *lpRect);
extern int __stdcall DlgDirListA(struct HWND__ *hDlg, char *lpPathSpec,
                                 int nIDListBox, int nIDStaticPath, unsigned int uFileType);
extern int __stdcall DlgDirListW(struct HWND__ *hDlg, char *lpPathSpec,
                                 int nIDListBox, int nIDStaticPath, unsigned int uFileType);
extern int __stdcall DlgDirSelectExA(struct HWND__ *hDlg, char *lpString,
                                     int nCount, int nIDListBox);
extern int __stdcall DlgDirSelectExW(struct HWND__ *hDlg, char *lpString,
                                     int nCount, int nIDListBox);
extern int __stdcall DlgDirListComboBoxA(struct HWND__ *hDlg, char *lpPathSpec,
                                         int nIDComboBox, int nIDStaticPath, unsigned int uFiletype);
extern int __stdcall DlgDirListComboBoxW(struct HWND__ *hDlg, char *lpPathSpec,
                                         int nIDComboBox, int nIDStaticPath, unsigned int uFiletype);
extern int __stdcall DlgDirSelectComboBoxExA(struct HWND__ *hDlg,
                                             char *lpString, int nCount, int nIDComboBox);
extern int __stdcall DlgDirSelectComboBoxExW(struct HWND__ *hDlg,
                                             char *lpString, int nCount, int nIDComboBox);
extern int __stdcall SetScrollInfo(struct HWND__ *, int, const struct tagSCROLLINFO *,
                                   int);
extern int __stdcall GetScrollInfo(struct HWND__ *, int, struct tagSCROLLINFO *);
extern long __stdcall DefFrameProcA(struct HWND__ *hWnd, struct HWND__ *hWndMDIClient,
                                    unsigned int uMsg, unsigned int wParam, long lParam);
extern long __stdcall DefFrameProcW(struct HWND__ *hWnd, struct HWND__ *hWndMDIClient,
                                    unsigned int uMsg, unsigned int wParam, long lParam);
extern long __stdcall DefMDIChildProcA(struct HWND__ *hWnd, unsigned int uMsg,
                                       unsigned int wParam, long lParam);
extern long __stdcall DefMDIChildProcW(struct HWND__ *hWnd, unsigned int uMsg,
                                       unsigned int wParam, long lParam);
extern int __stdcall TranslateMDISysAccel(struct HWND__ *hWndClient,
                                          struct tagMSG *lpMsg);
extern unsigned int __stdcall ArrangeIconicWindows(struct HWND__ *hWnd);
extern struct HWND__ *__stdcall CreateMDIWindowA(char *lpClassName,
                                                 char *lpWindowName, unsigned long dwStyle, int X, int Y, int nWidth,
                                                 int nHeight, struct HWND__ *hWndParent, struct HINSTANCE__ *hInstance,
                                                 long lParam);
extern struct HWND__ *__stdcall CreateMDIWindowW(char *lpClassName,
                                                 char *lpWindowName, unsigned long dwStyle, int X, int Y, int nWidth,
                                                 int nHeight, struct HWND__ *hWndParent, struct HINSTANCE__ *hInstance,
                                                 long lParam);
extern unsigned short __stdcall TileWindows(struct HWND__ *hwndParent,
                                            unsigned int wHow, const struct tagRECT *lpRect, unsigned int cKids,
                                            struct HWND__ *const *lpKids);
extern unsigned short __stdcall CascadeWindows(struct HWND__ *hwndParent,
                                               unsigned int wHow, const struct tagRECT *lpRect, unsigned int cKids,
                                               struct HWND__ *const *lpKids);
extern int __stdcall WinHelpA(struct HWND__ *hWndMain, const char *lpszHelp,
                              unsigned int uCommand, unsigned long dwData);
extern int __stdcall WinHelpW(struct HWND__ *hWndMain, const char *lpszHelp,
                              unsigned int uCommand, unsigned long dwData);
extern int __stdcall SystemParametersInfoA(unsigned int uiAction,
                                           unsigned int uiParam, void *pvParam, unsigned int fWinIni);
extern int __stdcall SystemParametersInfoW(unsigned int uiAction,
                                           unsigned int uiParam, void *pvParam, unsigned int fWinIni);
extern void __stdcall SetDebugErrorLevel(unsigned long dwLevel);
extern void __stdcall SetLastErrorEx(unsigned long dwErrCode, unsigned long dwType);
extern int __stdcall AddFontResourceA(const char *);
extern int __stdcall AddFontResourceW(const char *);
extern int __stdcall AnimatePalette(struct HPALETTE__ *, unsigned int,
                                    unsigned int, const struct tagPALETTEENTRY *);
extern int __stdcall Arc(struct HDC__ *, int, int, int, int, int,
                         int, int, int);
extern int __stdcall BitBlt(struct HDC__ *, int, int, int, int,
                            struct HDC__ *, int, int, unsigned long);
extern int __stdcall CancelDC(struct HDC__ *);
extern int __stdcall Chord(struct HDC__ *, int, int, int, int,
                           int, int, int, int);
extern int __stdcall ChoosePixelFormat(struct HDC__ *, const struct tagPIXELFORMATDESCRIPTOR *);
extern struct HMETAFILE__ *__stdcall CloseMetaFile(struct HDC__ *);
extern int __stdcall CombineRgn(struct HRGN__ *, struct HRGN__ *,
                                struct HRGN__ *, int);
extern struct HMETAFILE__ *__stdcall CopyMetaFileA(struct HMETAFILE__ *,
                                                   const char *);
extern struct HMETAFILE__ *__stdcall CopyMetaFileW(struct HMETAFILE__ *,
                                                   const char *);
extern struct HBITMAP__ *__stdcall CreateBitmap(int, int, unsigned int,
                                                unsigned int, const void *);
extern struct HBITMAP__ *__stdcall CreateBitmapIndirect(const struct tagBITMAP *);
extern struct HBRUSH__ *__stdcall CreateBrushIndirect(const struct tagLOGBRUSH *);
extern struct HBITMAP__ *__stdcall CreateCompatibleBitmap(struct HDC__ *,
                                                          int, int);
extern struct HBITMAP__ *__stdcall CreateDiscardableBitmap(struct HDC__ *,
                                                           int, int);
extern struct HDC__ *__stdcall CreateCompatibleDC(struct HDC__ *);
extern struct HDC__ *__stdcall CreateDCA(const char *, const char *,
                                         const char *, const struct _devicemodeA *);
extern struct HDC__ *__stdcall CreateDCW(const char *, const char *,
                                         const char *, const struct _devicemodeW *);
extern struct HBITMAP__ *__stdcall CreateDIBitmap(struct HDC__ *,
                                                  const struct tagBITMAPINFOHEADER *, unsigned long, const void *,
                                                  const struct tagBITMAPINFO *, unsigned int);
extern struct HBRUSH__ *__stdcall CreateDIBPatternBrush(void *,
                                                        unsigned int);
extern struct HBRUSH__ *__stdcall CreateDIBPatternBrushPt(const void *,
                                                          unsigned int);
extern struct HRGN__ *__stdcall CreateEllipticRgn(int, int, int,
                                                  int);
extern struct HRGN__ *__stdcall CreateEllipticRgnIndirect(const struct tagRECT *);
extern struct HFONT__ *__stdcall CreateFontIndirectA(const struct tagLOGFONTA *);
extern struct HFONT__ *__stdcall CreateFontIndirectW(const struct tagLOGFONTW *);
extern struct HFONT__ *__stdcall CreateFontA(int, int, int, int,
                                             int, unsigned long, unsigned long, unsigned long, unsigned long,
                                             unsigned long, unsigned long, unsigned long, unsigned long, const char *);
extern struct HFONT__ *__stdcall CreateFontW(int, int, int, int,
                                             int, unsigned long, unsigned long, unsigned long, unsigned long,
                                             unsigned long, unsigned long, unsigned long, unsigned long, const char *);
extern struct HBRUSH__ *__stdcall CreateHatchBrush(int, unsigned long);
extern struct HDC__ *__stdcall CreateICA(const char *, const char *,
                                         const char *, const struct _devicemodeA *);
extern struct HDC__ *__stdcall CreateICW(const char *, const char *,
                                         const char *, const struct _devicemodeW *);
extern struct HDC__ *__stdcall CreateMetaFileA(const char *);
extern struct HDC__ *__stdcall CreateMetaFileW(const char *);
extern struct HPALETTE__ *__stdcall CreatePalette(const struct tagLOGPALETTE *);
extern struct HPEN__ *__stdcall CreatePen(int, int, unsigned long);
extern struct HPEN__ *__stdcall CreatePenIndirect(const struct tagLOGPEN *);
extern struct HRGN__ *__stdcall CreatePolyPolygonRgn(const struct tagPOINT *,
                                                     const int *, int, int);
extern struct HBRUSH__ *__stdcall CreatePatternBrush(struct HBITMAP__ *);
extern struct HRGN__ *__stdcall CreateRectRgn(int, int, int, int);
extern struct HRGN__ *__stdcall CreateRectRgnIndirect(const struct tagRECT *);
extern struct HRGN__ *__stdcall CreateRoundRectRgn(int, int, int,
                                                   int, int, int);
extern int __stdcall CreateScalableFontResourceA(unsigned long,
                                                 const char *, const char *, const char *);
extern int __stdcall CreateScalableFontResourceW(unsigned long,
                                                 const char *, const char *, const char *);
extern struct HBRUSH__ *__stdcall CreateSolidBrush(unsigned long);
extern int __stdcall DeleteDC(struct HDC__ *);
extern int __stdcall DeleteMetaFile(struct HMETAFILE__ *);
extern int __stdcall DeleteObject(void *);
extern int __stdcall DescribePixelFormat(struct HDC__ *, int, unsigned int,
                                         struct tagPIXELFORMATDESCRIPTOR *);
extern int __stdcall DrawEscape(struct HDC__ *, int, int, const char *);
extern int __stdcall Ellipse(struct HDC__ *, int, int, int, int);
extern int __stdcall EnumFontFamiliesExA(struct HDC__ *, struct tagLOGFONTA *,
                                         int (__stdcall *)(const struct tagLOGFONTA *, const struct tagTEXTMETRICA *,
                                         unsigned long, long), long, unsigned long);
extern int __stdcall EnumFontFamiliesExW(struct HDC__ *, struct tagLOGFONTW *,
                                         int (__stdcall *)(const struct tagLOGFONTW *, const struct tagTEXTMETRICW *,
                                         unsigned long, long), long, unsigned long);
extern int __stdcall EnumFontFamiliesA(struct HDC__ *, const char *,
                                       int (__stdcall *)(const struct tagLOGFONTA *, const struct tagTEXTMETRICA *,
                                       unsigned long, long), long);
extern int __stdcall EnumFontFamiliesW(struct HDC__ *, const char *,
                                       int (__stdcall *)(const struct tagLOGFONTW *, const struct tagTEXTMETRICW *,
                                       unsigned long, long), long);
extern int __stdcall EnumFontsA(struct HDC__ *, const char *, int (__stdcall *)(const struct tagLOGFONTA *,
                                const struct tagTEXTMETRICA *, unsigned long, long), long);
extern int __stdcall EnumFontsW(struct HDC__ *, const char *, int (__stdcall *)(const struct tagLOGFONTW *,
                                const struct tagTEXTMETRICW *, unsigned long, long), long);
extern int __stdcall EnumObjects(struct HDC__ *, int, int (__stdcall *)(void *,
                                 long), long);
extern int __stdcall EqualRgn(struct HRGN__ *, struct HRGN__ *);
extern int __stdcall Escape(struct HDC__ *, int, int, const char *,
                            void *);
extern int __stdcall ExtEscape(struct HDC__ *, int, int, const char *,
                               int, char *);
extern int __stdcall ExcludeClipRect(struct HDC__ *, int, int,
                                     int, int);
extern struct HRGN__ *__stdcall ExtCreateRegion(const struct tagXFORM *,
                                                unsigned long, const struct _RGNDATA *);
extern int __stdcall ExtFloodFill(struct HDC__ *, int, int, unsigned long,
                                  unsigned int);
extern int __stdcall FillRgn(struct HDC__ *, struct HRGN__ *, struct HBRUSH__ *);
extern int __stdcall FloodFill(struct HDC__ *, int, int, unsigned long);
extern int __stdcall FrameRgn(struct HDC__ *, struct HRGN__ *,
                              struct HBRUSH__ *, int, int);
extern int __stdcall GetROP2(struct HDC__ *);
extern int __stdcall GetAspectRatioFilterEx(struct HDC__ *, struct tagSIZE *);
extern unsigned long __stdcall GetBkColor(struct HDC__ *);
extern int __stdcall GetBkMode(struct HDC__ *);
extern long __stdcall GetBitmapBits(struct HBITMAP__ *, long, void *);
extern int __stdcall GetBitmapDimensionEx(struct HBITMAP__ *, struct tagSIZE *);
extern unsigned int __stdcall GetBoundsRect(struct HDC__ *, struct tagRECT *,
                                            unsigned int);
extern int __stdcall GetBrushOrgEx(struct HDC__ *, struct tagPOINT *);
extern int __stdcall GetCharWidthA(struct HDC__ *, unsigned int,
                                   unsigned int, int *);
extern int __stdcall GetCharWidthW(struct HDC__ *, unsigned int,
                                   unsigned int, int *);
extern int __stdcall GetCharWidth32A(struct HDC__ *, unsigned int,
                                     unsigned int, int *);
extern int __stdcall GetCharWidth32W(struct HDC__ *, unsigned int,
                                     unsigned int, int *);
extern int __stdcall GetCharWidthFloatA(struct HDC__ *, unsigned int,
                                        unsigned int, float *);
extern int __stdcall GetCharWidthFloatW(struct HDC__ *, unsigned int,
                                        unsigned int, float *);
extern int __stdcall GetCharABCWidthsA(struct HDC__ *, unsigned int,
                                       unsigned int, struct _ABC *);
extern int __stdcall GetCharABCWidthsW(struct HDC__ *, unsigned int,
                                       unsigned int, struct _ABC *);
extern int __stdcall GetCharABCWidthsFloatA(struct HDC__ *, unsigned int,
                                            unsigned int, struct _ABCFLOAT *);
extern int __stdcall GetCharABCWidthsFloatW(struct HDC__ *, unsigned int,
                                            unsigned int, struct _ABCFLOAT *);
extern int __stdcall GetClipBox(struct HDC__ *, struct tagRECT *);
extern int __stdcall GetClipRgn(struct HDC__ *, struct HRGN__ *);
extern int __stdcall GetMetaRgn(struct HDC__ *, struct HRGN__ *);
extern void *__stdcall GetCurrentObject(struct HDC__ *, unsigned int);
extern int __stdcall GetCurrentPositionEx(struct HDC__ *, struct tagPOINT *);
extern int __stdcall GetDeviceCaps(struct HDC__ *, int);
extern int __stdcall GetDIBits(struct HDC__ *, struct HBITMAP__ *,
                               unsigned int, unsigned int, void *, struct tagBITMAPINFO *, unsigned int);
extern unsigned long __stdcall GetFontData(struct HDC__ *, unsigned long,
                                           unsigned long, void *, unsigned long);
extern unsigned long __stdcall GetGlyphOutlineA(struct HDC__ *,
                                                unsigned int, unsigned int, struct _GLYPHMETRICS *, unsigned long,
                                                void *, const struct _MAT2 *);
extern unsigned long __stdcall GetGlyphOutlineW(struct HDC__ *,
                                                unsigned int, unsigned int, struct _GLYPHMETRICS *, unsigned long,
                                                void *, const struct _MAT2 *);
extern int __stdcall GetGraphicsMode(struct HDC__ *);
extern int __stdcall GetMapMode(struct HDC__ *);
extern unsigned int __stdcall GetMetaFileBitsEx(struct HMETAFILE__ *,
                                                unsigned int, void *);
extern struct HMETAFILE__ *__stdcall GetMetaFileA(const char *);
extern struct HMETAFILE__ *__stdcall GetMetaFileW(const char *);
extern unsigned long __stdcall GetNearestColor(struct HDC__ *,
                                               unsigned long);
extern unsigned int __stdcall GetNearestPaletteIndex(struct HPALETTE__ *,
                                                     unsigned long);
extern unsigned long __stdcall GetObjectType(void *h);
extern unsigned int __stdcall GetOutlineTextMetricsA(struct HDC__ *,
                                                     unsigned int, struct _OUTLINETEXTMETRICA *);
extern unsigned int __stdcall GetOutlineTextMetricsW(struct HDC__ *,
                                                     unsigned int, struct _OUTLINETEXTMETRICW *);
extern unsigned int __stdcall GetPaletteEntries(struct HPALETTE__ *,
                                                unsigned int, unsigned int, struct tagPALETTEENTRY *);
extern unsigned long __stdcall GetPixel(struct HDC__ *, int, int);
extern int __stdcall GetPixelFormat(struct HDC__ *);
extern int __stdcall GetPolyFillMode(struct HDC__ *);
extern int __stdcall GetRasterizerCaps(struct _RASTERIZER_STATUS *,
                                       unsigned int);
extern unsigned long __stdcall GetRegionData(struct HRGN__ *, unsigned long,
                                             struct _RGNDATA *);
extern int __stdcall GetRgnBox(struct HRGN__ *, struct tagRECT *);
extern void *__stdcall GetStockObject(int);
extern int __stdcall GetStretchBltMode(struct HDC__ *);
extern unsigned int __stdcall GetSystemPaletteEntries(struct HDC__ *,
                                                      unsigned int, unsigned int, struct tagPALETTEENTRY *);
extern unsigned int __stdcall GetSystemPaletteUse(struct HDC__ *);
extern int __stdcall GetTextCharacterExtra(struct HDC__ *);
extern unsigned int __stdcall GetTextAlign(struct HDC__ *);
extern unsigned long __stdcall GetTextColor(struct HDC__ *);
extern int __stdcall GetTextExtentPointA(struct HDC__ *, const char *,
                                         int, struct tagSIZE *);
extern int __stdcall GetTextExtentPointW(struct HDC__ *, const char *,
                                         int, struct tagSIZE *);
extern int __stdcall GetTextExtentPoint32A(struct HDC__ *, const char *,
                                           int, struct tagSIZE *);
extern int __stdcall GetTextExtentPoint32W(struct HDC__ *, const char *,
                                           int, struct tagSIZE *);
extern int __stdcall GetTextExtentExPointA(struct HDC__ *, const char *,
                                           int, int, int *, int *, struct tagSIZE *);
extern int __stdcall GetTextExtentExPointW(struct HDC__ *, const char *,
                                           int, int, int *, int *, struct tagSIZE *);
extern int __stdcall GetTextCharset(struct HDC__ *hdc);
extern int __stdcall TranslateCharsetInfo(unsigned long *lpSrc,
                                          struct tagCHARSETINFO *lpCs, unsigned long dwFlags);
extern unsigned long __stdcall GetFontLanguageInfo(struct HDC__ *);
extern unsigned long __stdcall GetCharacterPlacementA(struct HDC__ *,
                                                      const char *, int, int, struct tagGCP_RESULTSA *, unsigned long);
extern unsigned long __stdcall GetCharacterPlacementW(struct HDC__ *,
                                                      const char *, int, int, struct tagGCP_RESULTSW *, unsigned long);
extern int __stdcall GetViewportExtEx(struct HDC__ *, struct tagSIZE *);
extern int __stdcall GetViewportOrgEx(struct HDC__ *, struct tagPOINT *);
extern int __stdcall GetWindowExtEx(struct HDC__ *, struct tagSIZE *);
extern int __stdcall GetWindowOrgEx(struct HDC__ *, struct tagPOINT *);
extern int __stdcall IntersectClipRect(struct HDC__ *, int, int,
                                       int, int);
extern int __stdcall InvertRgn(struct HDC__ *, struct HRGN__ *);
extern int __stdcall LineDDA(int, int, int, int, void (__stdcall *)(int,
                             int, long), long);
extern int __stdcall LineTo(struct HDC__ *, int, int);
extern int __stdcall MaskBlt(struct HDC__ *, int, int, int, int,
                             struct HDC__ *, int, int, struct HBITMAP__ *, int, int, unsigned long);
extern int __stdcall PlgBlt(struct HDC__ *, const struct tagPOINT *,
                            struct HDC__ *, int, int, int, int, struct HBITMAP__ *, int, int);
extern int __stdcall OffsetClipRgn(struct HDC__ *, int, int);
extern int __stdcall OffsetRgn(struct HRGN__ *, int, int);
extern int __stdcall PatBlt(struct HDC__ *, int, int, int, int,
                            unsigned long);
extern int __stdcall Pie(struct HDC__ *, int, int, int, int, int,
                         int, int, int);
extern int __stdcall PlayMetaFile(struct HDC__ *, struct HMETAFILE__ *);
extern int __stdcall PaintRgn(struct HDC__ *, struct HRGN__ *);
extern int __stdcall PolyPolygon(struct HDC__ *, const struct tagPOINT *,
                                 const int *, int);
extern int __stdcall PtInRegion(struct HRGN__ *, int, int);
extern int __stdcall PtVisible(struct HDC__ *, int, int);
extern int __stdcall RectInRegion(struct HRGN__ *, const struct tagRECT *);
extern int __stdcall RectVisible(struct HDC__ *, const struct tagRECT *);
extern int __stdcall Rectangle(struct HDC__ *, int, int, int, int);
extern int __stdcall RestoreDC(struct HDC__ *, int);
extern struct HDC__ *__stdcall ResetDCA(struct HDC__ *, const struct _devicemodeA *);
extern struct HDC__ *__stdcall ResetDCW(struct HDC__ *, const struct _devicemodeW *);
extern unsigned int __stdcall RealizePalette(struct HDC__ *);
extern int __stdcall RemoveFontResourceA(const char *);
extern int __stdcall RemoveFontResourceW(const char *);
extern int __stdcall RoundRect(struct HDC__ *, int, int, int, int,
                               int, int);
extern int __stdcall ResizePalette(struct HPALETTE__ *, unsigned int);
extern int __stdcall SaveDC(struct HDC__ *);
extern int __stdcall SelectClipRgn(struct HDC__ *, struct HRGN__ *);
extern int __stdcall ExtSelectClipRgn(struct HDC__ *, struct HRGN__ *,
                                      int);
extern int __stdcall SetMetaRgn(struct HDC__ *);
extern void *__stdcall SelectObject(struct HDC__ *, void *);
extern struct HPALETTE__ *__stdcall SelectPalette(struct HDC__ *,
                                                  struct HPALETTE__ *, int);
extern unsigned long __stdcall SetBkColor(struct HDC__ *, unsigned long);
extern int __stdcall SetBkMode(struct HDC__ *, int);
extern long __stdcall SetBitmapBits(struct HBITMAP__ *, unsigned long,
                                    const void *);
extern unsigned int __stdcall SetBoundsRect(struct HDC__ *, const struct tagRECT *,
                                            unsigned int);
extern int __stdcall SetDIBits(struct HDC__ *, struct HBITMAP__ *,
                               unsigned int, unsigned int, const void *, const struct tagBITMAPINFO *,
                               unsigned int);
extern int __stdcall SetDIBitsToDevice(struct HDC__ *, int, int,
                                       unsigned long, unsigned long, int, int, unsigned int, unsigned int,
                                       const void *, const struct tagBITMAPINFO *, unsigned int);
extern unsigned long __stdcall SetMapperFlags(struct HDC__ *, unsigned long);
extern int __stdcall SetGraphicsMode(struct HDC__ *hdc, int iMode);
extern int __stdcall SetMapMode(struct HDC__ *, int);
extern struct HMETAFILE__ *__stdcall SetMetaFileBitsEx(unsigned int,
                                                       const unsigned char *);
extern unsigned int __stdcall SetPaletteEntries(struct HPALETTE__ *,
                                                unsigned int, unsigned int, const struct tagPALETTEENTRY *);
extern unsigned long __stdcall SetPixel(struct HDC__ *, int, int,
                                        unsigned long);
extern int __stdcall SetPixelV(struct HDC__ *, int, int, unsigned long);
extern int __stdcall SetPixelFormat(struct HDC__ *, int, const struct tagPIXELFORMATDESCRIPTOR *);
extern int __stdcall SetPolyFillMode(struct HDC__ *, int);
extern int __stdcall StretchBlt(struct HDC__ *, int, int, int,
                                int, struct HDC__ *, int, int, int, int, unsigned long);
extern int __stdcall SetRectRgn(struct HRGN__ *, int, int, int,
                                int);
extern int __stdcall StretchDIBits(struct HDC__ *, int, int, int,
                                   int, int, int, int, int, const void *, const struct tagBITMAPINFO *,
                                   unsigned int, unsigned long);
extern int __stdcall SetROP2(struct HDC__ *, int);
extern int __stdcall SetStretchBltMode(struct HDC__ *, int);
extern unsigned int __stdcall SetSystemPaletteUse(struct HDC__ *,
                                                  unsigned int);
extern int __stdcall SetTextCharacterExtra(struct HDC__ *, int);
extern unsigned long __stdcall SetTextColor(struct HDC__ *, unsigned long);
extern unsigned int __stdcall SetTextAlign(struct HDC__ *, unsigned int);
extern int __stdcall SetTextJustification(struct HDC__ *, int,
                                          int);
extern int __stdcall UpdateColors(struct HDC__ *);
extern int __stdcall PlayMetaFileRecord(struct HDC__ *, struct tagHANDLETABLE *,
                                        struct tagMETARECORD *, unsigned int);
extern int __stdcall EnumMetaFile(struct HDC__ *, struct HMETAFILE__ *,
                                  int (__stdcall *)(struct HDC__ *, struct tagHANDLETABLE *, struct tagMETARECORD *,
                                  int, long), long);
extern struct HENHMETAFILE__ *__stdcall CloseEnhMetaFile(struct HDC__ *);
extern struct HENHMETAFILE__ *__stdcall CopyEnhMetaFileA(struct HENHMETAFILE__ *,
                                                         const char *);
extern struct HENHMETAFILE__ *__stdcall CopyEnhMetaFileW(struct HENHMETAFILE__ *,
                                                         const char *);
extern struct HDC__ *__stdcall CreateEnhMetaFileA(struct HDC__ *,
                                                  const char *, const struct tagRECT *, const char *);
extern struct HDC__ *__stdcall CreateEnhMetaFileW(struct HDC__ *,
                                                  const char *, const struct tagRECT *, const char *);
extern int __stdcall DeleteEnhMetaFile(struct HENHMETAFILE__ *);
extern int __stdcall EnumEnhMetaFile(struct HDC__ *, struct HENHMETAFILE__ *,
                                     int (__stdcall *)(struct HDC__ *, struct tagHANDLETABLE *, const struct tagENHMETARECORD *,
                                     int, long), void *, const struct tagRECT *);
extern struct HENHMETAFILE__ *__stdcall GetEnhMetaFileA(const char *);
extern struct HENHMETAFILE__ *__stdcall GetEnhMetaFileW(const char *);
extern unsigned int __stdcall GetEnhMetaFileBits(struct HENHMETAFILE__ *,
                                                 unsigned int, unsigned char *);
extern unsigned int __stdcall GetEnhMetaFileDescriptionA(struct HENHMETAFILE__ *,
                                                         unsigned int, char *);
extern unsigned int __stdcall GetEnhMetaFileDescriptionW(struct HENHMETAFILE__ *,
                                                         unsigned int, char *);
extern unsigned int __stdcall GetEnhMetaFileHeader(struct HENHMETAFILE__ *,
                                                   unsigned int, struct tagENHMETAHEADER *);
extern unsigned int __stdcall GetEnhMetaFilePaletteEntries(struct HENHMETAFILE__ *,
                                                           unsigned int, struct tagPALETTEENTRY *);
extern unsigned int __stdcall GetWinMetaFileBits(struct HENHMETAFILE__ *,
                                                 unsigned int, unsigned char *, int, struct HDC__ *);
extern int __stdcall PlayEnhMetaFile(struct HDC__ *, struct HENHMETAFILE__ *,
                                     const struct tagRECT *);
extern int __stdcall PlayEnhMetaFileRecord(struct HDC__ *, struct tagHANDLETABLE *,
                                           const struct tagENHMETARECORD *, unsigned int);
extern struct HENHMETAFILE__ *__stdcall SetEnhMetaFileBits(unsigned int,
                                                           const unsigned char *);
extern struct HENHMETAFILE__ *__stdcall SetWinMetaFileBits(unsigned int,
                                                           const unsigned char *, struct HDC__ *, const struct tagMETAFILEPICT *);
extern int __stdcall GdiComment(struct HDC__ *, unsigned int, const unsigned char *);
extern int __stdcall GetTextMetricsA(struct HDC__ *, struct tagTEXTMETRICA *);
extern int __stdcall GetTextMetricsW(struct HDC__ *, struct tagTEXTMETRICW *);
extern int __stdcall AngleArc(struct HDC__ *, int, int, unsigned long,
                              float, float);
extern int __stdcall PolyPolyline(struct HDC__ *, const struct tagPOINT *,
                                  const unsigned long *, unsigned long);
extern int __stdcall GetWorldTransform(struct HDC__ *, struct tagXFORM *);
extern int __stdcall SetWorldTransform(struct HDC__ *, const struct tagXFORM *);
extern int __stdcall ModifyWorldTransform(struct HDC__ *, const struct tagXFORM *,
                                          unsigned long);
extern int __stdcall CombineTransform(struct tagXFORM *, const struct tagXFORM *,
                                      const struct tagXFORM *);
extern struct HBITMAP__ *__stdcall CreateDIBSection(struct HDC__ *,
                                                    const struct tagBITMAPINFO *, unsigned int, void **, void *, unsigned long);
extern unsigned int __stdcall GetDIBColorTable(struct HDC__ *,
                                               unsigned int, unsigned int, struct tagRGBQUAD *);
extern unsigned int __stdcall SetDIBColorTable(struct HDC__ *,
                                               unsigned int, unsigned int, const struct tagRGBQUAD *);
extern int __stdcall SetColorAdjustment(struct HDC__ *, const struct tagCOLORADJUSTMENT *);
extern int __stdcall GetColorAdjustment(struct HDC__ *, struct tagCOLORADJUSTMENT *);
extern struct HPALETTE__ *__stdcall CreateHalftonePalette(struct HDC__ *);
extern int __stdcall StartDocA(struct HDC__ *, const struct _DOCINFOA *);
extern int __stdcall StartDocW(struct HDC__ *, const struct _DOCINFOW *);
extern int __stdcall EndDoc(struct HDC__ *);
extern int __stdcall StartPage(struct HDC__ *);
extern int __stdcall EndPage(struct HDC__ *);
extern int __stdcall AbortDoc(struct HDC__ *);
extern int __stdcall SetAbortProc(struct HDC__ *, int (__stdcall *)(struct HDC__ *,
                                  int));
extern int __stdcall AbortPath(struct HDC__ *);
extern int __stdcall ArcTo(struct HDC__ *, int, int, int, int,
                           int, int, int, int);
extern int __stdcall BeginPath(struct HDC__ *);
extern int __stdcall CloseFigure(struct HDC__ *);
extern int __stdcall EndPath(struct HDC__ *);
extern int __stdcall FillPath(struct HDC__ *);
extern int __stdcall FlattenPath(struct HDC__ *);
extern int __stdcall GetPath(struct HDC__ *, struct tagPOINT *,
                             unsigned char *, int);
extern struct HRGN__ *__stdcall PathToRegion(struct HDC__ *);
extern int __stdcall PolyDraw(struct HDC__ *, const struct tagPOINT *,
                              const unsigned char *, int);
extern int __stdcall SelectClipPath(struct HDC__ *, int);
extern int __stdcall SetArcDirection(struct HDC__ *, int);
extern int __stdcall SetMiterLimit(struct HDC__ *, float, float *);
extern int __stdcall StrokeAndFillPath(struct HDC__ *);
extern int __stdcall StrokePath(struct HDC__ *);
extern int __stdcall WidenPath(struct HDC__ *);
extern struct HPEN__ *__stdcall ExtCreatePen(unsigned long, unsigned long,
                                             const struct tagLOGBRUSH *, unsigned long, const unsigned long *);
extern int __stdcall GetMiterLimit(struct HDC__ *, float *);
extern int __stdcall GetArcDirection(struct HDC__ *);
extern int __stdcall GetObjectA(void *, int, void *);
extern int __stdcall GetObjectW(void *, int, void *);
extern int __stdcall MoveToEx(struct HDC__ *, int, int, struct tagPOINT *);
extern int __stdcall TextOutA(struct HDC__ *, int, int, const char *,
                              int);
extern int __stdcall TextOutW(struct HDC__ *, int, int, const char *,
                              int);
extern int __stdcall ExtTextOutA(struct HDC__ *, int, int, unsigned int,
                                 const struct tagRECT *, const char *, unsigned int, const int *);
extern int __stdcall ExtTextOutW(struct HDC__ *, int, int, unsigned int,
                                 const struct tagRECT *, const char *, unsigned int, const int *);
extern int __stdcall PolyTextOutA(struct HDC__ *, const struct tagPOLYTEXTA *,
                                  int);
extern int __stdcall PolyTextOutW(struct HDC__ *, const struct tagPOLYTEXTW *,
                                  int);
extern struct HRGN__ *__stdcall CreatePolygonRgn(const struct tagPOINT *,
                                                 int, int);
extern int __stdcall DPtoLP(struct HDC__ *, struct tagPOINT *,
                            int);
extern int __stdcall LPtoDP(struct HDC__ *, struct tagPOINT *,
                            int);
extern int __stdcall Polygon(struct HDC__ *, const struct tagPOINT *,
                             int);
extern int __stdcall Polyline(struct HDC__ *, const struct tagPOINT *,
                              int);
extern int __stdcall PolyBezier(struct HDC__ *, const struct tagPOINT *,
                                unsigned long);
extern int __stdcall PolyBezierTo(struct HDC__ *, const struct tagPOINT *,
                                  unsigned long);
extern int __stdcall PolylineTo(struct HDC__ *, const struct tagPOINT *,
                                unsigned long);
extern int __stdcall SetViewportExtEx(struct HDC__ *, int, int,
                                      struct tagSIZE *);
extern int __stdcall SetViewportOrgEx(struct HDC__ *, int, int,
                                      struct tagPOINT *);
extern int __stdcall SetWindowExtEx(struct HDC__ *, int, int, struct tagSIZE *);
extern int __stdcall SetWindowOrgEx(struct HDC__ *, int, int, struct tagPOINT *);
extern int __stdcall OffsetViewportOrgEx(struct HDC__ *, int, int,
                                         struct tagPOINT *);
extern int __stdcall OffsetWindowOrgEx(struct HDC__ *, int, int,
                                       struct tagPOINT *);
extern int __stdcall ScaleViewportExtEx(struct HDC__ *, int, int,
                                        int, int, struct tagSIZE *);
extern int __stdcall ScaleWindowExtEx(struct HDC__ *, int, int,
                                      int, int, struct tagSIZE *);
extern int __stdcall SetBitmapDimensionEx(struct HBITMAP__ *, int,
                                          int, struct tagSIZE *);
extern int __stdcall SetBrushOrgEx(struct HDC__ *, int, int, struct tagPOINT *);
extern int __stdcall GetTextFaceA(struct HDC__ *, int, char *);
extern int __stdcall GetTextFaceW(struct HDC__ *, int, char *);
extern unsigned long __stdcall GetKerningPairsA(struct HDC__ *,
                                                unsigned long, struct tagKERNINGPAIR *);
extern unsigned long __stdcall GetKerningPairsW(struct HDC__ *,
                                                unsigned long, struct tagKERNINGPAIR *);
extern int __stdcall GetDCOrgEx(struct HDC__ *, struct tagPOINT *);
extern int __stdcall FixBrushOrgEx(struct HDC__ *, int, int, struct tagPOINT *);
extern int __stdcall UnrealizeObject(void *);
extern int __stdcall GdiFlush(void);
extern unsigned long __stdcall GdiSetBatchLimit(unsigned long);
extern unsigned long __stdcall GdiGetBatchLimit(void);
extern int __stdcall SetICMMode(struct HDC__ *, int);
extern int __stdcall CheckColorsInGamut(struct HDC__ *, void *,
                                        void *, unsigned long);
extern void *__stdcall GetColorSpace(struct HDC__ *);
extern int __stdcall GetLogColorSpaceA(struct HCOLORSPACE__ *,
                                       struct tagLOGCOLORSPACEA *, unsigned long);
extern int __stdcall GetLogColorSpaceW(struct HCOLORSPACE__ *,
                                       struct tagLOGCOLORSPACEW *, unsigned long);
extern struct HCOLORSPACE__ *__stdcall CreateColorSpaceA(struct tagLOGCOLORSPACEA *);
extern struct HCOLORSPACE__ *__stdcall CreateColorSpaceW(struct tagLOGCOLORSPACEW *);
extern int __stdcall SetColorSpace(struct HDC__ *, struct HCOLORSPACE__ *);
extern int __stdcall DeleteColorSpace(struct HCOLORSPACE__ *);
extern int __stdcall GetICMProfileA(struct HDC__ *, unsigned long *,
                                    char *);
extern int __stdcall GetICMProfileW(struct HDC__ *, unsigned long *,
                                    char *);
extern int __stdcall SetICMProfileA(struct HDC__ *, char *);
extern int __stdcall SetICMProfileW(struct HDC__ *, char *);
extern int __stdcall GetDeviceGammaRamp(struct HDC__ *, void *);
extern int __stdcall SetDeviceGammaRamp(struct HDC__ *, void *);
extern int __stdcall ColorMatchToTarget(struct HDC__ *, struct HDC__ *,
                                        unsigned long);
extern int __stdcall EnumICMProfilesA(struct HDC__ *, int (__stdcall *)(char *,
                                      long), long);
extern int __stdcall EnumICMProfilesW(struct HDC__ *, int (__stdcall *)(char *,
                                      long), long);
extern int __stdcall SwapBuffers(struct HDC__ *);

#ifndef _NI_WC_ /* watcom 10.5 unsupported SDK functions */
    extern int __stdcall PostQueuedCompletionStatus(void *CompletionPort,
                                                    unsigned long dwNumberOfBytesTransferred, unsigned long dwCompletionKey,
                                                    struct _OVERLAPPED *lpOverlapped);
    extern void __stdcall GetSystemTimeAsFileTime(struct _FILETIME *lpSystemTimeAsFileTime);
    extern unsigned long __stdcall GetProcessVersion(unsigned long ProcessId);
    extern unsigned long __stdcall GetPrivateProfileSectionNamesA(char *lpszReturnBuffer,
    unsigned long nSize, const char *lpFileName);
    extern unsigned long __stdcall GetPrivateProfileSectionNamesW(char *lpszReturnBuffer,
    unsigned long nSize, const char *lpFileName);
    extern int __stdcall GetPrivateProfileStructA(const char *lpszSection,
                                                  const char *lpszKey, void *lpStruct, unsigned int uSizeStruct,
                                                  const char *szFile);
    extern int __stdcall GetPrivateProfileStructW(const char *lpszSection,
                                                  const char *lpszKey, void *lpStruct, unsigned int uSizeStruct,
                                                  const char *szFile);
    extern int __stdcall WritePrivateProfileStructA(const char *lpszSection,
                                                    const char *lpszKey, void *lpStruct, unsigned int uSizeStruct,
                                                    const char *szFile);
    extern int __stdcall WritePrivateProfileStructW(const char *lpszSection,
                                                    const char *lpszKey, void *lpStruct, unsigned int uSizeStruct,
                                                    const char *szFile);
    extern int __stdcall GetSystemPowerStatus(struct _SYSTEM_POWER_STATUS *lpSystemPowerStatus);
    extern int __stdcall SetSystemPowerState(int fSuspend, int fForce);
    extern char *__stdcall CharPrevExA(unsigned short CodePage, const char *lpStart,
                                       const char *lpCurrentChar, unsigned long dwFlags);
#ifndef _NI_BC_  /* borland 5.0 unsupported SDK functions */
    extern int __stdcall EnumDesktopWindows(struct HDESK__ *hDesktop,
                                            int (__stdcall *lpfn)(struct HWND__ *, long), long lParam);
    extern unsigned int __stdcall MapVirtualKeyExW(unsigned int uCode,
                                                   unsigned int uMapType, struct HKL__ *dwhkl);
    extern int __stdcall SetWindowRgn(struct HWND__ *hWnd, struct HRGN__ *hRgn,
                                      int bRedraw);
    extern int __stdcall GetWindowRgn(struct HWND__ *hWnd, struct HRGN__ *hRgn);
    extern long __stdcall ChangeDisplaySettingsA(struct _devicemodeA *lpDevMode,
                                                 unsigned long dwFlags);
    extern long __stdcall ChangeDisplaySettingsW(struct _devicemodeW *lpDevMode,
                                                 unsigned long dwFlags);
    extern int __stdcall EnumDisplaySettingsA(const char *lpszDeviceName,
                                              unsigned long iModeNum, struct _devicemodeA *lpDevMode);
    extern int __stdcall EnumDisplaySettingsW(const char *lpszDeviceName,
                                              unsigned long iModeNum, struct _devicemodeW *lpDevMode);
    extern int __stdcall GetTextCharsetInfo(struct HDC__ *hdc, struct tagFONTSIGNATURE *lpSig,
                                            unsigned long dwFlags);
    extern int __stdcall UpdateICMRegKeyA(unsigned long, unsigned long,
                                          char *, unsigned int);
    extern int __stdcall UpdateICMRegKeyW(unsigned long, unsigned long,
                                          char *, unsigned int);
#endif /* ndef _NI_BC_ */
#endif /* ndef _NI_WC_ */
